C     Last change:  RR   24 Jun 2004   10:13 am
        PROGRAM ASOSRAW

C       Program to reformat Bakersfield ASOS data to ISCST3 input format

        CHARACTER*1 aws_tmp
        CHARACTER*1 comment
        CHARACTER*2 atemp_tmp
        CHARACTER*3 awd_tmp
        CHARACTER*5 change_code(2)
        CHARACTER*20 sky
        CHARACTER*35 outfile(5)

        Real ws(12,31,24),ws_knts
        Real temp(12,31,24)
        REAL cover(12,31,24)
        REAL temp_tmp,ws_tmp
        REAL cover2,cover3
        REAL rday,rhr
        REAL xlat,xlon
        REAL vector(12,31,24),lvector
        REAL rand,wd_tmp_real
        REAL missval

        Integer height(12,31,24),wd(12,31,24)
        INTEGER height2,height3
        INTEGER wd_tmp
        INTEGER num
        INTEGER lyr
        INTEGER dap(12)
        INTEGER missval_vec
        INTEGER cover_int(12,31,24),lcover
        INTEGER temp_int(12,31,24)
        INTEGER kst(12,31,24)
        INTEGER zone
        INTEGER icomp(12,31)

        xlat = 35.43     ! coordiantes for Bakersfield
        xlon = 119.05
        zone = 8

C       codes for missing data replacement.  HOUR is code for using the average of nearest
C       4 hours, and DAY is the code for using average of same hour from day before and after.
C       These codes appear in Bakersfield_subs.out file

        change_code(1) = 'HOUR '
        change_code(2) = 'DAY  '


        DATA dap /31,29,31,30,31,30,31,31,30,31,30,31/

        ifile = 0
        icalm = 0
        imiss = 0

        iwd_comp = 0
        iws_comp = 0
        icover_comp = 0
        iheight_comp = 0

        OPEN(1,FILE='c:\arvesta\asos-Final\Bakersfield_ASOS_9903.out',
     >   STATUS='old')
        READ(1,*)               ! read header
        OPEN(9,FILE='c:\arvesta\asos-Final\Bakersfield_subs.out')  ! records missing data substitutions
        WRITE(9,3)
3       FORMAT(' Missing Data Substitutions by EPA methods,'//)

        OPEN(3,FILE='c:\arvesta\asos-Final\checkfile.out')

C       open output files by year

        OUTFILE(1) = 'c:\arvesta\asos-Final\BAK99.dat'
        OUTFILE(2) = 'c:\arvesta\asos-Final\BAK00.dat'
        OUTFILE(3) = 'c:\arvesta\asos-Final\BAK01.dat'
        OUTFILE(4) = 'c:\arvesta\asos-Final\BAK02.dat'
        OUTFILE(5) = 'c:\arvesta\asos-Final\BAK03.dat'

C       initialize arrays

        do 5 i=1,12
         do 5 j=1,31
          icomp(i,j) = 1
          do 5 k=1,24
            ws(i,j,k) = 999.0
            wd(i,j,k) = 999
            temp(i,j,k) = 999.0
            height(i,j,k) = 999
            cover(i,j,k) = 999.0
            cover_int(i,j,k) = 999
            vector(i,j,k) =  999
            kst(i,j,k) = -9
5      continue

C       read ASOS data

        do 50 i=1,100000

          READ(1,*,IOSTAT=ios,ERR=59) iyr,imon,rday,rhr,sky,temp_tmp,
     >      ws_tmp,awd_tmp
          BACKSPACE(1)
          READ(1,*,IOSTAT=ios,ERR=59) iyr,imon,rday,rhr,sky,atemp_tmp,
     >     aws_tmp,awd_tmp

          iday = INT(rday)
          ihr = INT(rhr)

          IF(atemp_tmp(2:2) .EQ. '-') temp_tmp = 999
          IF(aws_tmp .EQ. '-')  ws_tmp = 999

          IF(awd_tmp .EQ. 'VRB') then                   ! assign a random direction if wd = "variable"
           call random_number(rand)
           ws_tmp_real = 0.
           do j=1,360
             IF(rand .LE. (float(j)/360.)) then
               ws_tmp_real = float(j)
               GOTO 59
             endif
           end do
           IF(ws_tmp_real .EQ. 0.)
     >       PRINT *, 'Failed to assign wd to variable wind'
          ELSEIF(awd_tmp(1:1) .EQ. '-') then
            wd_tmp = 999.
          else
            CALL chartonum(awd_tmp,wd_tmp,iyr,imon,iday,ihr)        ! convert character to number
          endif


59        IF(ios .LT. 0) iyr = iyr + 1         ! allow last day to be processed

C       if a year has been completed, then write the output file; otherwise read data one hour at a time
C       until a full year is read

          IF(i .GT. 1 .AND. lyr .NE. iyr) then

            ifile = ifile + 1
            OPEN(2,FILE=outfile(ifile))

C           skip leap year day for non-leap years

            IF(MOD(lyr,4) .NE. 0) then
              dap(2) = 28
              itot = 365*24
              ileap = 0
            else
              dap(2) = 29
              itot = 366*24
              ileap = 1
            endif



C           Fill in missing data using EPA procedures

            do 40 ir=1,12
             do 40 jr=1,dap(ir)
              do 40 kr=1,24

                IF(ws(ir,jr,kr) .GT. 998) then
                  iws_comp = iws_comp + 1
                  call miss4scaler(ws,ir,jr,kr,missval,ileap,ichange)
                  IF(missval .LT. 999) then
                    ws(ir,jr,kr) = missval
                   WRITE(9,41) lyr,ir,jr,kr,missval,change_code(ichange)
41                 FORMAT(' WS     replaced at ',i4,1x,3(1x,i2),
     >               1x,f7.2,1x,a5)
                  endif
                endif

                IF(cover(ir,jr,kr) .GT. 98) then
                  icover_comp = icover_comp + 1
                  call miss4scaler(cover,ir,jr,kr,missval,ileap,ichange)
                  IF(missval .LT. 999) then
                    cover(ir,jr,kr) = missval
                   WRITE(9,42) lyr,ir,jr,kr,missval,change_code(ichange)
42                 FORMAT(' COVER  replaced at ',i4,1x,3(1x,i2),
     >               1x,f7.2,1x,a5)
                  endif
                endif

                IF(height(ir,jr,kr) .GT. 998) then
                iheight_comp = iheight_comp + 1
                call miss4scaler_integer(height,ir,jr,kr,imissval,ileap)
                  IF(imissval .LT. 999) then
                    height(ir,jr,kr) = imissval
                  WRITE(9,43) lyr,ir,jr,kr,imissval,change_code(ichange)
43                FORMAT(' HEIGHT replaced at ',i4,1x,3(1x,i2),
     >              1x,i4,1x,a5)
                  endif
                endif


                IF(wd(ir,jr,kr) .GT. 998) then
                iwd_comp = iwd_comp + 1
                call miss4vector(wd,ir,jr,kr,imissval,ileap,ichange)
                  IF(imissval .LT. 999) then
                    wd(ir,jr,kr) = imissval
                  WRITE(9,44) lyr,ir,jr,kr,imissval,change_code(ichange)
44                FORMAT(' WD     replaced at ',i4,1x,3(1x,i2),
     >              1x,i5,1x,a5)
                  endif
                endif

40          continue

C           Process met data and calculate stability classes

            lwd = 0
            inum = -1
            lvector = 0
            lcover = 999
            do 55 ir=1,12
             do 55 jr=1,dap(ir)
              do 55 kr=1,24


C               convert wind direction to vector format and randomize

                CALL GetJul(ijul,ir,jr)

                kr_tmp = kr
                CALL FLOVEC(kr_tmp,ijul,wd(ir,jr,kr),vector(ir,jr,kr))

C               convert cloud cover to tenths

                IF(cover(ir,jr,kr) .LT. 998) then
                  cover_int(ir,jr,kr) = INT(cover(ir,jr,kr)*10)
                else
                  cover_int(ir,jr,kr) = 999
                endif


C               Calculate solar angle with PCRAMMET code

                CALL Sun(ijul,kr,xlon,xlat,zone,solarangle,
     >            sunris,sunset)

C               estimate stability class with PCRAMMET algorithm

                IF(inum .EQ. -1) then
                  inum = 1
                else
                  inum = 0
                endif


                IF(ws(ir,jr,kr).lt.998.and.cover_int(ir,jr,kr).lt.98
     >            .and.height(ir,jr,kr).lt.998.) then

                  ws_knts = ws(ir,jr,kr)*1.94                   ! convert ws to knots for stabit
                  CALL stabit(inum,ijul,kr,kst(ir,jr,kr),ws_knts,
     >              height(ir,jr,kr),cover_int(ir,jr,kr),solarangle,
     >              sunris,sunset)

C                   print out a month of data to check results

                    IF(lyr .eq. 2000) then
                      WRITE(3,51) lyr,ir,jr,kr,ws(ir,jr,kr),
     >                  wd(ir,jr,kr),height(ir,jr,kr),
     >                  cover_int(ir,jr,kr),temp(ir,jr,kr),
     >                  solarangle,sunris,sunset,kst(ir,jr,kr)
51                    FORMAT(4(1x,i4),1x,f7.2,1x,i4,1x,i4,1x,i2,1x,f7.2,
     >                 3(1x,f7.2),1x,i2)
                    endif


                else
                  kst(ir,jr,kr) = -9
                endif
C
C               implement the calms policy - set wind speeds less than 3 knots to 0 - also
C               do this for winds with a direction of 0

                IF(ws_knts .LT. 2.5 .or. wd(ir,jr,kr) .eq. 0) then
                  ws(ir,jr,kr) = 0.0
                  vector(ir,jr,kr) = lvector
                  icalm = icalm + 1
                endif

C               find out if the data is complete

                IF(ws(ir,jr,kr) .gt. 998) icomp(ir,jr) = 0
                IF(cover(ir,jr,kr) .gt. 998) icomp(ir,jr) = 0
                IF(temp(ir,jr,kr) .gt. 998) temp(ir,jr,kr) = 25         ! assign to nominal value since the model doesn't use it
                IF(wd(ir,jr,kr) .gt. 998) icomp(ir,jr) = 0
                IF(height(ir,jr,kr) .gt. 998) icomp(ir,jr) = 0


                lvector = vector(ir,jr,kr)
                lcover = cover(ir,jr,kr)

55          continue

            do 56 ir=1,12
             do 56 jr=1,dap(ir)
              IF(icomp(ir,jr) .EQ. 0) then
                PRINT *, 'Missing data for :',lyr,ir,jr
                WRITE(9,58) lyr,ir,jr
58	        FORMAT(' *** Missing data for : ',i4,2(i3))
                imiss = imiss + 1
                GOTO 56
              endif
              do 57 kr=1,24

                IF(lyr .gt. 1999) THEN   ! reduce to last two digits
                  iyrprnt = lyr - 2000
                else
                  iyrprnt = lyr - 1900
                endif

C               convert temperature from Celsius to K

                temp(ir,jr,kr) = temp(ir,jr,kr) + 273.


                IF(kst(ir,jr,kr) .EQ. -9) then
                  PRINT *, 'Missing stability:',
     >            lyr,ir,jr,kr
                  PRINT *, ws(ir,jr,kr)
                  PRINT *, cover_int(ir,jr,kr)
                  PRINT *, height(ir,jr,kr)
                endif

                WRITE(2,901) iyrprnt,ir,jr,kr,vector(ir,jr,kr),
     >            ws(ir,jr,kr),temp(ir,jr,kr),kst(ir,jr,kr)
901             FORMAT(4(i2.2),f9.4,f9.4,f6.1,i2,'  300.0','  300.0')

57           continue
56          continue


C          reinitilize variables

           do 67 ir=1,12
            do 67 jr=1,31
             icomp(ir,jr) = 1
             do 67 kr=1,24
               ws(ir,jr,kr) = 999.0
               wd(ir,jr,kr) = 999
               temp(ir,jr,kr) = 999.0
               cover(ir,jr,kr) = 999.0
               height(ir,jr,kr) = 999
               vector(ir,jr,kr) = 999
               kst(ir,jr,kr) = -9
               cover_int(ir,jr,kr) = 999
67          continue

            CLOSE(2)

           PRINT *, 'Finished with ',lyr

         endif


C       otherwise if not the end of a year, store and process the data into arrays
C       one hour at a time

          ws(imon,iday,ihr) = ws_tmp
          wd(imon,iday,ihr) = wd_tmp
          temp(imon,iday,ihr) = temp_tmp


          IF(sky(1:1) .EQ. '-') then         ! sky cover is missing
            cover(imon,iday,ihr) = 999
            height(imon,iday,ihr) = 999
            GOTO 49
          endif

          IF(sky(1:2) .EQ. 'VV') then
            cover(imon,iday,ihr) = 0.1
          ELSEIF(sky(1:3) .EQ. 'CLR') then
            cover(imon,iday,ihr) = 0.0
          ELSEIF(sky(1:3) .EQ. 'FEW') then
            cover(imon,iday,ihr) = 0.2
          ELSEIF(sky(1:3) .EQ. 'SCT') then
            cover(imon,iday,ihr) = 0.3
          ELSEIF(sky(1:3) .EQ. 'BKN') then
            cover(imon,iday,ihr) = 0.7
          ELSEIF(sky(1:3) .EQ. 'OVC') then
            cover(imon,iday,ihr) = 1.0
          else
            PRINT *, 'Unknown cloud type - layer 1 ',iyr,imon,iday,
     >        ihr,sky(1:6)
          endif

          IF(sky(4:4) .NE. ' ') then
            IF(sky(1:2) .eq. 'VV') then
              CALL chartonum(sky(3:5),num,iyr,imon,iday,ihr)
              height(imon,iday,ihr) = num
            else
              CALL chartonum(sky(4:6),num,iyr,imon,iday,ihr)
              height(imon,iday,ihr) = num
            endif
          else
            height(imon,iday,ihr) = 0
          endif

C         check for second cloud layer

          icloud2 = 0
          IF(sky(8:8) .NE. ' ') icloud2 = 1
          IF(icloud2 .EQ. 0) GOTO 49

          IF(height(imon,iday,ihr) .EQ. 0) PRINT *, ' Zero height'

          IF(sky(8:10) .EQ. 'CLR') then
            cover2 = 0.0
          ELSEIF(sky(8:10) .EQ. 'FEW') then
            cover2 = 0.0
          ELSEIF(sky(8:10) .EQ. 'SCT') then
            cover2 = 0.3
          ELSEIF(sky(8:10) .EQ. 'BKN') then
            cover2 = 0.7
          ELSEIF(sky(8:10) .EQ. 'OVC') then
            cover2 = 1.0
          else
            PRINT *, 'Unknown cloud type - layer 2 ',iyr,imon,iday,
     >       ihr,sky(8:13)
          endif

          CALL chartonum(sky(11:13),num,iyr,imon,iday,ihr)
          height2 = num

C         use largest cloud cover and lowest ceiling height EPA(1997)

          IF(cover2 .GT. cover(imon,iday,ihr)) then
            cover(imon,iday,ihr) = cover2
          endif
          IF(height2 .LT. height(imon,iday,ihr)) then
            height(imon,iday,ihr) = height2
          endif

C         check for third cloud layer

          icloud3 = 0
          IF(sky(15:17) .NE. ' ') icloud3 = 1
          IF(icloud3 .EQ. 0) GOTO 49

          IF(sky(15:17) .EQ. 'CLR') then
            cover3 = 0.0
          ELSEIF(sky(15:17) .EQ. 'FEW') then
            cover2 = 0.2
          ELSEIF(sky(15:17) .EQ. 'SCT') then
            cover3 = 0.3
          ELSEIF(sky(15:17) .EQ. 'BKN') then
            cover3 = 0.7
          ELSEIF(sky(15:17) .EQ. 'OVC') then
            cover3 = 1.0
          else
            PRINT *, 'Unknown cloud type - layer 3 ',iyr,imon,iday,
     >        ihr,sky(8:13)
          endif

          CALL chartonum(sky(18:20),num,iyr,imon,iday,ihr)
          height3 = num

C         use largest cloud cover and lowest ceiling height EPA(1997)

          IF(cover3 .GT. cover(imon,iday,ihr)) then
            cover(imon,iday,ihr) = cover3
          endif
          IF(height3 .LT. height(imon,iday,ihr)) then
            height(imon,iday,ihr) = height3
          endif

49        lyr = iyr

          IF(ios .LT. 0) GOTO 99           ! if last day is processed, jump out of loop

50      continue

99      CLOSE(1)
        CLOSE(3)
        CLOSE(9)

        PRINT *, 'icalm = ',icalm
        PRINT *, 'imiss = ',imiss


        PRINT *, 'wd comp ', iwd_comp
        PRINT *, 'cover comp ',icover_comp
        PRINT *, 'height comp ',iheight_comp
        PRINT *, 'ws comp ',iws_comp

        END PROGRAM


        SUBROUTINE CHARTONUM(sky,num,iyr,imon,iday,ihr)

        CHARACTER*3 sky

        INTEGER isky(3)
        integer num

        do 10 i=1,3
          select case (sky(i:i))
              case ('0')
                isky(i) = 0
              case ('1')
                isky(i) = 1
              CASE('2')
                isky(i) = 2
              CASE('3')
                isky(i) = 3
              CASE('4')
                isky(i) = 4
              CASE('5')
                isky(i) = 5
              CASE('6')
                isky(i) = 6
              CASE('7')
                isky(i) = 7
              CASE('8')
                isky(i) = 8
              CASE('9')
                isky(i) = 9
              case default
                PRINT*, ' Problem with case construct ',sky(1:3),
     >            sky(i:i),iyr,imon,iday,ihr
          end select
10      continue

        num = 100*isky(1)+10*isky(2)+isky(3)

        END SUBROUTINE


       SUBROUTINE SUN(JULDAY,IHOUR,XLON,XLAT,ZONE,
     >  SOLARANGLE,SUNRIS,SUNSET)
C***********************************************************************
C*    SUN Module of PCRAMMET Meteorological Pre-processor
C*
C*    PURPOSE: This routine calculates the sunrise and sunset times
C*             of the day from the date, latitude, longitude, and time
C*             zone
C*
C*    PROGRAMMER: Jayant Hardikar
C*                PES Inc.
C*                Adapted From MPRM
C*
C*    DATE:       February 23, 1995
C*
C*    INPUTS:     Latitude, longitude, Julian day
C*
C*    OUTPUTS:    Sunrise, sunset, solar elevation for each hour of day
C*
C*    CALLED FROM: MAIN program
C***********************************************************************
C*
C*    Variable Declarations

C*    ZONE 05 = EASTERN
C*    ZONE 06 = CENTRAL
C*    ZONE 07 = MOUNTAIN
C*    ZONE 08 = PACIFIC                                

      REAL CONST,DUM,TEMPZ,SINLAT,COSLAT,DAYNO,TDAYNO
      REAL COSD,SINTD,COSTD,SIGMA,DSIN,DCOS,AMM,HCOS,H2
      REAL SUNRIS,SUNSET,HI,ALFSN,ALF 
      REAL SOLARANGLE
      
      REAL XLAT,XLON
      
      INTEGER ZONE

      DATA CONST /57.29578/                               
      
      ITZONE = ZONE
      
C*
      DUM    = XLON/15.0 - ITZONE
      TEMPZ  = 15.0*ITZONE - XLON
      SINLAT = SIN(XLAT/CONST )
      COSLAT = COS(XLAT/CONST )

C---- Determine the angular(radians) fraction of a year for this date;
C     the constant 0.0172028=360./(365.242*57.29578)
      DAYNO  = (JULDAY-1.0)*0.0172028
      TDAYNO = 2.0*DAYNO
      SIND   = SIN(DAYNO)
      COSD   = COS(DAYNO)
      SINTD  = SIN(TDAYNO)
      COSTD  = COS(TDAYNO)
C
C---- Account for ellipticity of earth's orbit.

      SIGMA = 279.9348 + (DAYNO*CONST) + 1.914827*SIND -
     &        0.079525*COSD + 0.019938*SINTD - 0.00162*COSTD

C---- Find the sine of the solar declination;
C     the constant 0.39785=sin(0.4091720193=23.44383/57.29578)

      DSIN = 0.39785*SIN(SIGMA/CONST)
      DCOS = SQRT(1.0-DSIN*DSIN)

C---- Determine time(hrs) of meridian passage

      AMM  = 12.0 + 0.12357*SIND - 0.004289*COSD + 0.153809*SINTD +
     &                                             0.060783*COSTD
      HCOS = (-SINLAT*DSIN)/(COSLAT*DCOS)

C---- Determine solar hour angle of sunrise-sunset.
      H2 = (ATAN2(SQRT(1.0-HCOS*HCOS),HCOS)/15.0)*CONST

C---- Time of sunrise(SUNRIS) and time of sunset(SUNSET) are expressed
C     in local standard time since the zone correction has already
C     been made; otherwise they would be in Greenwich mean time.
      SUNRIS = AMM - H2 + DUM
      SUNSET = AMM + H2 + DUM


C*    Calculate the solar elevation for all (daytime) hours

         IF(IHOUR .LE. SUNRIS) THEN
            SOLARANGLE= 0.0
         ELSEIF(IHOUR .GE. SUNSET)THEN
            SOLARANGLE = 0.0
         ELSE
C           Determine the angle of elevation and solar hour angle(radians)
            HI    = (15.0*(IHOUR-AMM)+TEMPZ)/CONST
            ALFSN = SINLAT*DSIN + DCOS*COSLAT*COS(HI)

C----       Determine solar elevation angle (in degrees).
            ALF   = ATAN2(ALFSN,SQRT(1.0-ALFSN*ALFSN))*CONST
            SOLARANGLE = ALF
         ENDIF



      RETURN
      END

      SUBROUTINE STABIT(INUM,IJUL,IHR,KST,KSPEED,ICEIL,ICOVER,
     >  SOLARANGLE,SUNRIS,SUNSET)
C***********************************************************************
C*    STABIT      Module of PCRAMMET Meteorological Pre-processor
C*
C*    PURPOSE: This Routine Calculates Hourly Stability Classes
C*
C*    PROGRAMMER: Jayant Hardikar
C*                PES Inc.
C*                Adapted From MPRM
C*
C*    DATE:       February 23, 1995
C*
C*    INPUTS:     Wind speed, ciling height, cloud cover,
C*                sunris/sunset/solar elevation angle
C*
C*    OUTPUTS:    Pasquill-Gifford Stability Category
C*
C*    CALLED FROM: MAIN program
C***********************************************************************
C*
C*    Variable Declarations
      REAL ANGL(3),KSPEED
      REAL SOLARANGLE,SUNRIS,SUNSET
      INTEGER LSTAB(12,7)
      DATA ANGL /60.0, 35.0, 15.0/
      DATA LSTAB /7,7,7,6,6,6,5,5,5,5,4,4,
     &            6,6,6,5,5,5,4,4,4,4,4,4,
     &            4,4,4,4,4,4,4,4,4,4,4,4,
     &            3,3,3,4,4,4,4,4,4,4,4,4,
     &            2,2,2,3,3,3,3,3,3,4,4,4,
     &            1,2,2,2,2,2,2,3,3,3,3,4,
     &            1,1,1,1,1,2,2,2,2,3,3,3/

C*    INITIALIZE STABILITY BEFORE IT IS CALCULATED
      KST       = 9
      ISPD      = 0
      IRADX     = 0



C*    Determine the wind speed index based on the wind speed (in knots)
      ISPD = KSPEED
      IF((kspeed-FLOAT(ispd)) .GE. 0.5) ispd = ispd + 1
      IF( ISPD .LT. 1 )  ISPD = 1
      IF( ISPD .GT. 12 ) ISPD = 12

      ICLHT = ICEIL
      ISKY  = ICOVER

      IF( ISKY .LE. 10  .AND.  KSPEED .LT. 90 )THEN

C*       DETERMINE RADIATION INDEX.
         IF (ISKY .EQ. 10 .AND. ICLHT .LT. 70) THEN

C*          LOW/MIDDLE OVERCAST CLOUD LAYER: NEUTRAL CONDITIONS
            IRADX = 3

         ELSE IF (IHR .GT. SUNRIS .AND. IHR .LT. SUNSET) THEN

C*          Daytime conditions
            DO 220 I=1,3
               IF (SOLARANGLE .GT. ANGL(I)) GO TO 230
220         CONTINUE
            I=4
230         ICN=5-I
            IF (ISKY .GT. 5) GO TO 240
            IRADX=ICN+3
            GO TO 280
240         IRADX=ICN-1
            IF (ICLHT .LT. 70) GO TO 250
            IF (ICLHT .LT. 160) GO TO 260
            IF (ISKY .EQ. 10) GO TO 270
            IRADX=ICN
            GO TO 270
250         IRADX=ICN-2
            GO TO 270
260         IF (ISKY .EQ. 10) IRADX=IRADX-1
270         IF (IRADX .LT. 1) IRADX=1
            IRADX=IRADX+3

         ELSE
C*          Nighttime conditions
            IRADX=2
            IF (ISKY .LE. 4) IRADX=1

         END IF
C
C*       Determine stability.


280      KST = LSTAB(ISPD,IRADX)

C*       Do not allow stability to vary by more than one category hour-to-hour

         IF (inum .eq. 1) LST=KST
         IF ((KST-LST).GT.1) KST=LST+1
         IF ((LST-KST).GT.1) KST=LST-1
         LST=KST

      ENDIF

      IF (KST .LT. 1) THEN
        WRITE(*,1042)
1042    FORMAT(' STABILITY NOT DEFINED ',i3,1x,i2)
      END IF

      RETURN
      END

      SUBROUTINE GETJUL(IJUL,IMON,IDAY)

      INTEGER DPM(12)

      DATA DPM /31,30,28,30,31,30,31,31,30,31,30,31/

      IJUL = 0
      DO 10 I=1,IMON
       DO 10 J=1,DPM(I)
         IJUL = IJUL + 1
         IF(I .EQ. IMON .AND. J .EQ. IDAY) GOTO 20
10    CONTINUE

      IF(I .EQ. 2 .AND. J .EQ. 29) IJUL = 60            ! leap year

20    CONTINUE

      END SUBROUTINE

      SUBROUTINE FLOVEC(IHR,JDAY,wd,vector)
C***********************************************************************
C*    FLOVEC Module of PCRAMMET Meteorological Pre-processor
C*
C*    PURPOSE: This Routine Converts The Meteorological Wind Direction
C*             To Flow Vector and Also Calculates Random Flow Vector
C*
C*    PROGRAMMER: Jayant Hardikar
C*                PES Inc.
C*
C*    DATE:       February 23, 1995
C*
C*    INPUTS:     Wind direction, array of random numbers
C*
C*    OUTPUTS:    Flow vector for the hour
C*
C*    CALLED FROM: MAIN program
C***********************************************************************

C*    Variable Declarations

      INTEGER KRAND
      COMMON /BDATA/ IRAND(24,366)

      INTEGER wd

      REAL vector

C*    Calculate flow vector and random flow vector only if the
C*    wind direciton is NOT missing.


      IF(wd .LT. 900 )THEN

         IF(wd.GT.180.0) THEN
            vector=float(wd)-180.0
         ELSE
            vector=float(wd)+180.0
         ENDIF

C*       IHR AND JDAY, THE LOOP CONTROL VARIABLES, ARE BEING USED AS
C*       INDICES INTO THE RANDOM NUMBER ARRAY KRAND(24,366).
C*       IRAND IS SINGLE DIGIT FROM 0 TO 9.

         KRAND = IRAND(IHR,JDAY)
         vector = vector + KRAND - 4.0
         IF (vector.GT.360.0) vector=vector-360.0

      ELSE
         vector = 999.0

      ENDIF

      RETURN
      END

      BLOCK DATA
C***********************************************************************
C*    BLOCK Block Data for the PCRAMMET Meteorological Pre-processor
C*
C*    PURPOSE:    Initializes Block Data
C*
C*    PROGRAMMER: Jayant Hardikar
C*                PES Inc.
C*
C*    DATE:       February 13, 1995
C*
C*    INPUTS:
C*
C*
C*    OUTPUTS:
C*
C***********************************************************************
C*
C*    Variable Declarations

      INTEGER IRAND,KRAND(8784)
      COMMON /BDATA/ IRAND(24,366)
      EQUIVALENCE (IRAND(1,1), KRAND(1))

      DATA (KRAND(I),I=1,456)
     1/5,2,8,7,7,6,9,7,1,5,8,0,7,3,6,8,5,1,8,1,4,6,4,4,
     20,6,6,4,0,1,3,0,4,5,9,5,3,1,4,8,2,5,6,9,8,9,1,2,
     34,0,8,4,1,3,0,3,2,8,6,2,5,6,1,4,3,5,1,2,1,3,5,1,
     40,0,2,3,5,6,0,2,0,1,1,7,9,6,5,4,7,3,1,3,1,3,6,2,
     59,8,1,4,6,9,6,9,3,2,2,3,2,4,9,2,3,0,1,1,6,4,2,6,
     60,7,9,7,6,0,2,6,2,2,9,0,5,9,6,6,6,9,2,5,6,0,6,0,
     72,7,4,9,7,0,3,8,4,8,7,6,5,0,1,9,8,8,5,6,2,6,5,9,
     83,5,2,9,1,9,9,5,4,4,3,1,3,8,6,3,2,4,7,6,7,2,4,8,
     99,0,0,8,0,3,7,8,4,8,5,1,8,9,4,7,5,8,0,5,3,4,8,9,
     15,7,4,9,2,9,8,8,0,6,5,7,9,0,0,2,2,1,7,3,9,6,2,5,
     24,8,7,8,7,8,6,5,6,9,1,4,9,8,1,5,7,0,3,8,0,0,5,3,
     32,3,8,0,1,2,2,6,7,5,2,3,2,2,5,3,0,3,6,9,0,1,9,4,
     43,2,7,3,8,4,1,7,5,7,6,5,4,1,5,0,1,8,4,0,2,5,4,2,
     58,7,2,4,6,0,6,8,4,4,2,1,7,5,1,0,6,0,9,7,0,1,1,4,
     64,6,2,4,9,4,3,6,1,1,6,4,8,4,7,0,7,1,5,6,8,7,3,4,
     70,3,1,3,8,6,6,2,6,1,5,6,6,4,5,9,0,5,3,4,0,0,3,6,
     81,2,3,8,7,1,4,5,8,6,0,9,0,2,8,6,2,3,3,1,2,2,5,3,
     94,3,3,7,9,6,3,2,7,6,1,1,5,9,5,9,3,3,9,4,3,5,7,0,
     11,1,9,0,7,2,6,6,1,5,8,3,4,4,5,7,8,2,4,8,1,5,2,0/
      DATA (KRAND(I),I=457, 912)
     */3,7,1,8,1,7,9,2,4,9,2,0,7,4,6,7,5,3,1,9,3,8,3,2,
     *3,4,3,4,1,5,3,1,9,4,6,9,3,0,4,2,2,8,0,3,0,1,2,3,
     *6,5,4,8,9,6,1,6,2,8,2,7,1,1,9,8,3,0,9,1,4,9,5,7,
     *4,1,4,4,3,5,3,1,9,3,0,8,4,3,4,7,6,9,8,5,1,1,1,4,
     *0,3,1,2,3,6,1,7,2,8,1,2,3,1,7,2,2,6,6,6,9,9,7,3,
     *4,6,8,9,5,9,0,5,8,6,5,2,7,6,6,4,0,5,5,4,2,4,1,4,
     *6,9,2,2,8,0,7,0,7,8,6,0,0,6,0,4,9,5,8,2,0,0,8,2,
     *5,6,5,5,2,5,1,4,5,6,7,4,0,1,8,0,2,5,0,0,2,5,0,0,
     *1,4,1,8,6,1,0,3,3,8,8,0,2,9,5,6,5,2,2,4,1,5,2,2,
     *1,6,9,5,2,8,7,8,7,3,7,4,7,5,9,8,4,1,7,1,3,6,8,2,
     *9,6,1,7,4,2,6,9,1,6,6,3,8,4,2,7,6,5,8,7,2,5,5,2,
     *8,2,6,5,7,1,9,6,0,8,2,0,1,8,3,0,2,3,0,3,5,2,0,7,
     *7,2,1,3,1,0,3,0,4,8,0,0,8,3,0,0,2,6,0,3,9,6,5,6,
     *6,9,7,9,3,7,0,0,9,0,5,0,7,0,6,4,2,8,2,1,7,4,3,7,
     *5,9,0,2,0,0,4,6,8,7,9,4,2,2,6,1,1,9,0,6,7,2,7,9,
     *1,1,0,9,6,2,1,3,8,0,9,7,7,1,9,6,0,6,9,8,0,8,6,2,
     *0,3,6,6,3,0,3,2,4,9,6,6,9,0,8,9,7,1,9,6,3,6,8,1,
     *2,7,4,0,2,1,8,3,8,2,2,0,8,3,9,6,6,6,2,5,3,6,1,1,
     *2,9,8,2,5,4,6,8,8,7,2,5,6,4,5,5,8,7,2,9,4,9,7,8/
      DATA (KRAND(I),I=913, 1368)
     */4,5,9,5,4,6,5,9,5,8,0,7,8,6,6,7,2,3,9,1,7,3,0,6,
     *3,8,0,1,5,2,0,1,4,5,5,8,3,0,1,2,6,1,1,3,0,9,9,5,
     *9,3,4,5,0,9,5,3,1,4,5,6,8,3,7,9,2,8,4,1,9,8,1,5,
     *0,7,8,6,1,0,7,2,7,9,5,5,2,6,9,9,8,1,5,7,5,0,0,8,
     *3,3,8,5,3,6,7,6,0,6,9,1,2,5,2,8,2,6,9,4,6,9,2,9,
     *8,9,3,1,8,6,1,4,3,5,8,5,3,1,4,3,4,9,8,0,3,3,2,0,
     *4,6,0,0,2,9,4,8,7,7,2,8,6,1,9,7,7,0,3,1,5,2,2,7,
     *7,6,6,4,2,1,5,8,0,2,0,9,2,6,2,0,8,0,0,9,5,8,4,8,
     *9,5,6,8,5,3,9,4,2,8,9,6,7,9,0,4,6,3,6,8,8,3,5,8,
     *0,6,5,8,5,1,9,5,2,5,9,8,2,8,8,6,3,3,8,2,4,6,7,0,
     *7,7,7,8,1,4,4,8,2,2,3,1,0,1,5,0,3,7,4,8,2,7,6,9,
     *3,3,2,0,3,2,4,1,8,5,4,7,6,6,1,1,8,1,6,4,2,3,1,2,
     *2,7,8,5,2,7,6,9,6,1,7,6,2,4,8,0,2,1,9,5,9,0,0,4,
     *4,8,2,2,8,2,8,0,8,0,6,8,5,7,2,2,2,5,6,8,3,7,6,0,
     *0,4,4,0,8,4,9,4,8,1,8,0,3,8,8,6,7,5,2,0,0,3,9,1,
     *0,2,4,3,5,7,9,5,6,5,3,0,0,9,0,1,0,0,9,6,6,4,2,7,
     *7,6,6,5,8,1,0,3,5,6,4,3,5,9,9,7,6,8,8,8,5,9,1,1,
     *8,9,2,1,9,7,6,7,6,0,7,0,0,4,9,5,2,5,2,1,4,0,8,8,
     *5,2,4,6,9,4,7,6,3,5,4,4,2,5,0,6,1,8,7,8,9,5,9,8/
      DATA (KRAND(I),I=1369, 1824)
     */2,1,7,6,9,8,7,7,9,3,5,3,2,9,9,9,0,5,2,3,0,9,2,1,
     *3,3,0,1,4,3,0,4,1,0,3,3,4,9,6,3,6,7,1,4,3,9,6,9,
     *3,3,2,1,8,2,9,6,2,8,8,1,9,9,8,9,5,9,3,3,3,3,7,4,
     *9,3,3,4,4,9,0,9,7,1,1,2,5,0,0,2,4,0,7,2,9,8,4,3,
     *3,2,3,7,9,8,3,2,7,8,1,9,0,0,7,7,6,3,7,0,6,2,5,9,
     *4,9,7,0,2,0,1,3,1,8,4,0,7,2,7,3,8,8,7,2,3,4,3,1,
     *4,4,0,1,4,1,9,5,0,8,3,5,9,8,4,5,3,7,3,8,0,2,8,1,
     *0,4,4,1,4,5,4,9,2,5,2,4,6,1,5,3,5,3,0,9,1,4,6,4,
     *8,6,5,0,1,5,0,5,0,2,0,7,3,6,2,4,6,6,5,3,2,4,9,4,
     *6,2,2,0,6,8,2,4,4,8,5,4,7,9,5,6,3,8,8,4,5,0,1,8,
     *3,7,2,6,4,6,9,4,6,0,9,0,6,8,4,8,9,9,0,0,2,1,1,2,
     *3,4,3,4,1,5,3,1,9,4,6,9,3,0,4,2,2,8,0,3,0,1,2,3,
     *6,5,4,8,9,6,1,6,2,8,2,7,1,1,9,8,3,0,9,1,4,9,5,7,
     *4,1,4,4,3,5,3,1,9,3,0,8,4,3,4,7,6,9,8,5,1,1,1,4,
     *0,3,1,2,3,6,1,7,2,8,1,2,3,1,7,2,2,6,6,6,9,9,7,3,
     *4,6,8,9,5,9,0,5,8,6,5,2,7,6,6,4,0,5,5,4,2,4,1,4,
     *6,9,2,2,8,0,7,0,7,8,6,0,0,6,0,4,9,5,8,2,0,0,8,2,
     *5,6,5,5,2,5,1,4,5,6,7,4,0,1,8,0,2,5,0,0,2,5,0,0,
     *1,4,1,8,6,1,0,3,3,8,8,0,2,9,5,6,5,2,2,4,1,5,2,2/
      DATA (KRAND(I),I=1825, 2280)
     */1,6,9,5,2,8,7,8,7,3,7,4,7,5,9,8,4,1,7,1,3,6,8,2,
     *9,6,1,7,4,2,6,9,1,6,6,3,8,4,2,7,6,5,8,7,2,5,5,2,
     *8,2,6,5,7,1,9,6,0,8,2,0,1,8,3,0,2,3,0,3,5,2,0,7,
     *7,2,1,3,1,0,3,0,4,8,0,0,8,3,0,0,2,6,0,3,9,6,5,6,
     *6,9,7,9,3,7,0,0,9,0,5,0,7,0,6,4,2,8,2,1,7,4,3,7,
     *5,9,0,2,0,0,4,6,8,7,9,4,2,2,6,1,1,9,0,6,7,2,7,9,
     *1,1,0,9,6,2,1,3,8,0,9,7,7,1,9,6,0,6,9,8,0,8,6,2,
     *0,3,6,6,3,0,3,2,4,9,6,6,9,0,8,9,7,1,9,6,3,6,8,1,
     *2,7,4,0,2,1,8,3,8,2,2,0,8,3,9,6,6,6,2,5,3,6,1,1,
     *2,9,8,2,5,4,6,8,8,7,2,5,6,4,5,5,8,7,2,9,4,9,7,8,
     *4,5,9,5,4,6,5,9,5,8,0,7,8,6,6,7,2,3,9,1,7,3,0,6,
     *3,8,0,1,5,2,0,1,4,5,5,8,3,0,1,2,6,1,1,3,0,9,9,5,
     *9,3,4,5,0,9,5,3,1,4,5,6,8,3,7,9,2,8,4,1,9,8,1,5,
     *0,7,8,6,1,0,7,2,7,9,5,5,2,6,9,9,8,1,5,7,5,0,0,8,
     *3,3,8,5,3,6,7,6,0,6,9,1,2,5,2,8,2,6,9,4,6,9,2,9,
     *8,9,3,1,8,6,1,4,3,5,8,5,3,1,4,3,4,9,8,0,3,3,2,0,
     *4,6,0,0,2,9,4,8,7,7,2,8,6,1,9,7,7,0,3,1,5,2,2,7,
     *7,6,6,4,2,1,5,8,0,2,0,9,2,6,2,0,8,0,0,9,5,8,4,8,
     *9,5,6,8,5,3,9,4,2,8,9,6,7,9,0,4,6,3,6,8,8,3,5,8/
      DATA (KRAND(I),I=2281, 2736)
     */0,6,5,8,5,1,9,5,2,5,9,8,2,8,8,6,3,3,8,2,4,6,7,0,
     *7,7,7,8,1,4,4,8,2,2,3,1,0,1,5,0,3,7,4,8,2,7,6,9,
     *3,3,2,0,3,2,4,1,8,5,4,7,6,6,1,1,8,1,6,4,2,3,1,2,
     *2,7,8,5,2,7,6,9,6,1,7,6,2,4,8,0,2,1,9,5,9,0,0,4,
     *4,8,2,2,8,2,8,0,8,0,6,8,5,7,2,2,2,5,6,8,3,7,6,0,
     *0,4,4,0,8,4,9,4,8,1,8,0,3,8,8,6,7,5,2,0,0,3,9,1,
     *0,2,4,3,5,7,9,5,6,5,3,0,0,9,0,1,0,0,9,6,6,4,2,7,
     *7,6,6,5,8,1,0,3,5,6,4,3,5,9,9,7,6,8,8,8,5,9,1,1,
     *8,9,2,1,9,7,6,7,6,0,7,0,0,4,9,5,2,5,2,1,4,0,8,8,
     *5,2,4,6,9,4,7,6,3,5,4,4,2,5,0,6,1,8,7,8,9,5,9,8,
     *2,1,7,6,9,8,7,7,9,3,5,3,2,9,9,9,0,5,2,3,0,9,2,1,
     *3,3,0,1,4,3,0,4,1,0,3,3,4,9,6,3,6,7,1,4,3,9,6,9,
     *3,3,2,1,8,2,9,6,2,8,8,1,9,9,8,9,5,9,3,3,3,3,7,4,
     *9,3,3,4,4,9,0,9,7,1,1,2,5,0,0,2,4,0,7,2,9,8,4,3,
     *3,2,3,7,9,8,3,2,7,8,1,9,0,0,7,7,6,3,7,0,6,2,5,9,
     *4,9,7,0,2,0,1,3,1,8,4,0,7,2,7,3,8,8,7,2,3,4,3,1,
     *4,4,0,1,4,1,9,5,0,8,3,5,9,8,4,5,3,7,3,8,0,2,8,1,
     *0,4,4,1,4,5,4,9,2,5,2,4,6,1,5,3,5,3,0,9,1,4,6,4,
     *8,6,5,0,1,5,0,5,0,2,0,7,3,6,2,4,6,6,5,3,2,4,9,4/
      DATA (KRAND(I),I=2737, 3192)
     */6,2,2,0,6,8,2,4,4,8,5,4,7,9,5,6,3,8,8,4,5,0,1,8,
     *3,7,2,6,4,6,9,4,6,0,9,0,6,8,4,8,9,9,0,0,2,1,1,2,
     *3,4,3,4,1,5,3,1,9,4,6,9,3,0,4,2,2,8,0,3,0,1,2,3,
     *6,5,4,8,9,6,1,6,2,8,2,7,1,1,9,8,3,0,9,1,4,9,5,7,
     *4,1,4,4,3,5,3,1,9,3,0,8,4,3,4,7,6,9,8,5,1,1,1,4,
     *0,3,1,2,3,6,1,7,2,8,1,2,3,1,7,2,2,6,6,6,9,9,7,3,
     *4,6,8,9,5,9,0,5,8,6,5,2,7,6,6,4,0,5,5,4,2,4,1,4,
     *6,9,2,2,8,0,7,0,7,8,6,0,0,6,0,4,9,5,8,2,0,0,8,2,
     *5,6,5,5,2,5,1,4,5,6,7,4,0,1,8,0,2,5,0,0,2,5,0,0,
     *1,4,1,8,6,1,0,3,3,8,8,0,2,9,5,6,5,2,2,4,1,5,2,2,
     *1,6,9,5,2,8,7,8,7,3,7,4,7,5,9,8,4,1,7,1,3,6,8,2,
     *9,6,1,7,4,2,6,9,1,6,6,3,8,4,2,7,6,5,8,7,2,5,5,2,
     *8,2,6,5,7,1,9,6,0,8,2,0,1,8,3,0,2,3,0,3,5,2,0,7,
     *7,2,1,3,1,0,3,0,4,8,0,0,8,3,0,0,2,6,0,3,9,6,5,6,
     *6,9,7,9,3,7,0,0,9,0,5,0,7,0,6,4,2,8,2,1,7,4,3,7,
     *5,9,0,2,0,0,4,6,8,7,9,4,2,2,6,1,1,9,0,6,7,2,7,9,
     *1,1,0,9,6,2,1,3,8,0,9,7,7,1,9,6,0,6,9,8,0,8,6,2,
     *0,3,6,6,3,0,3,2,4,9,6,6,9,0,8,9,7,1,9,6,3,6,8,1,
     *2,7,4,0,2,1,8,3,8,2,2,0,8,3,9,6,6,6,2,5,3,6,1,1/
      DATA (KRAND(I),I=3193, 3648)
     */2,9,8,2,5,4,6,8,8,7,2,5,6,4,5,5,8,7,2,9,4,9,7,8,
     *4,5,9,5,4,6,5,9,5,8,0,7,8,6,6,7,2,3,9,1,7,3,0,6,
     *3,8,0,1,5,2,0,1,4,5,5,8,3,0,1,2,6,1,1,3,0,9,9,5,
     *9,3,4,5,0,9,5,3,1,4,5,6,8,3,7,9,2,8,4,1,9,8,1,5,
     *0,7,8,6,1,0,7,2,7,9,5,5,2,6,9,9,8,1,5,7,5,0,0,8,
     *3,3,8,5,3,6,7,6,0,6,9,1,2,5,2,8,2,6,9,4,6,9,2,9,
     *8,9,3,1,8,6,1,4,3,5,8,5,3,1,4,3,4,9,8,0,3,3,2,0,
     *4,6,0,0,2,9,4,8,7,7,2,8,6,1,9,7,7,0,3,1,5,2,2,7,
     *7,6,6,4,2,1,5,8,0,2,0,9,2,6,2,0,8,0,0,9,5,8,4,8,
     *9,5,6,8,5,3,9,4,2,8,9,6,7,9,0,4,6,3,6,8,8,3,5,8,
     *0,6,5,8,5,1,9,5,2,5,9,8,2,8,8,6,3,3,8,2,4,6,7,0,
     *7,7,7,8,1,4,4,8,2,2,3,1,0,1,5,0,3,7,4,8,2,7,6,9,
     *3,3,2,0,3,2,4,1,8,5,4,7,6,6,1,1,8,1,6,4,2,3,1,2,
     *2,7,8,5,2,7,6,9,6,1,7,6,2,4,8,0,2,1,9,5,9,0,0,4,
     *4,8,2,2,8,2,8,0,8,0,6,8,5,7,2,2,2,5,6,8,3,7,6,0,
     *0,4,4,0,8,4,9,4,8,1,8,0,3,8,8,6,7,5,2,0,0,3,9,1,
     *0,2,4,3,5,7,9,5,6,5,3,0,0,9,0,1,0,0,9,6,6,4,2,7,
     *7,6,6,5,8,1,0,3,5,6,4,3,5,9,9,7,6,8,8,8,5,9,1,1,
     *8,9,2,1,9,7,6,7,6,0,7,0,0,4,9,5,2,5,2,1,4,0,8,8/
      DATA (KRAND(I),I=3649, 4104)
     */5,2,4,6,9,4,7,6,3,5,4,4,2,5,0,6,1,8,7,8,9,5,9,8,
     *2,1,7,6,9,8,7,7,9,3,5,3,2,9,9,9,0,5,2,3,0,9,2,1,
     *3,3,0,1,4,3,0,4,1,0,3,3,4,9,6,3,6,7,1,4,3,9,6,9,
     *3,3,2,1,8,2,9,6,2,8,8,1,9,9,8,9,5,9,3,3,3,3,7,4,
     *9,3,3,4,4,9,0,9,7,1,1,2,5,0,0,2,4,0,7,2,9,8,4,3,
     *3,2,3,7,9,8,3,2,7,8,1,9,0,0,7,7,6,3,7,0,6,2,5,9,
     *4,9,7,0,2,0,1,3,1,8,4,0,7,2,7,3,8,8,7,2,3,4,3,1,
     *4,4,0,1,4,1,9,5,0,8,3,5,9,8,4,5,3,7,3,8,0,2,8,1,
     *0,4,4,1,4,5,4,9,2,5,2,4,6,1,5,3,5,3,0,9,1,4,6,4,
     *8,6,5,0,1,5,0,5,0,2,0,7,3,6,2,4,6,6,5,3,2,4,9,4,
     *6,2,2,0,6,8,2,4,4,8,5,4,7,9,5,6,3,8,8,4,5,0,1,8,
     *3,7,2,6,4,6,9,4,6,0,9,0,6,8,4,8,9,9,0,0,2,1,1,2,
     *3,4,3,4,1,5,3,1,9,4,6,9,3,0,4,2,2,8,0,3,0,1,2,3,
     *6,5,4,8,9,6,1,6,2,8,2,7,1,1,9,8,3,0,9,1,4,9,5,7,
     *4,1,4,4,3,5,3,1,9,3,0,8,4,3,4,7,6,9,8,5,1,1,1,4,
     *0,3,1,2,3,6,1,7,2,8,1,2,3,1,7,2,2,6,6,6,9,9,7,3,
     *4,6,8,9,5,9,0,5,8,6,5,2,7,6,6,4,0,5,5,4,2,4,1,4,
     *6,9,2,2,8,0,7,0,7,8,6,0,0,6,0,4,9,5,8,2,0,0,8,2,
     *5,6,5,5,2,5,1,4,5,6,7,4,0,1,8,0,2,5,0,0,2,5,0,0/
      DATA (KRAND(I),I=4105, 4560)
     */1,4,1,8,6,1,0,3,3,8,8,0,2,9,5,6,5,2,2,4,1,5,2,2,
     *1,6,9,5,2,8,7,8,7,3,7,4,7,5,9,8,4,1,7,1,3,6,8,2,
     *9,6,1,7,4,2,6,9,1,6,6,3,8,4,2,7,6,5,8,7,2,5,5,2,
     *8,2,6,5,7,1,9,6,0,8,2,0,1,8,3,0,2,3,0,3,5,2,0,7,
     *7,2,1,3,1,0,3,0,4,8,0,0,8,3,0,0,2,6,0,3,9,6,5,6,
     *6,9,7,9,3,7,0,0,9,0,5,0,7,0,6,4,2,8,2,1,7,4,3,7,
     *5,9,0,2,0,0,4,6,8,7,9,4,2,2,6,1,1,9,0,6,7,2,7,9,
     *1,1,0,9,6,2,1,3,8,0,9,7,7,1,9,6,0,6,9,8,0,8,6,2,
     *0,3,6,6,3,0,3,2,4,9,6,6,9,0,8,9,7,1,9,6,3,6,8,1,
     *2,7,4,0,2,1,8,3,8,2,2,0,8,3,9,6,6,6,2,5,3,6,1,1,
     *2,9,8,2,5,4,6,8,8,7,2,5,6,4,5,5,8,7,2,9,4,9,7,8,
     *4,5,9,5,4,6,5,9,5,8,0,7,8,6,6,7,2,3,9,1,7,3,0,6,
     *3,8,0,1,5,2,0,1,4,5,5,8,3,0,1,2,6,1,1,3,0,9,9,5,
     *9,3,4,5,0,9,5,3,1,4,5,6,8,3,7,9,2,8,4,1,9,8,1,5,
     *0,7,8,6,1,0,7,2,7,9,5,5,2,6,9,9,8,1,5,7,5,0,0,8,
     *3,3,8,5,3,6,7,6,0,6,9,1,2,5,2,8,2,6,9,4,6,9,2,9,
     *8,9,3,1,8,6,1,4,3,5,8,5,3,1,4,3,4,9,8,0,3,3,2,0,
     *4,6,0,0,2,9,4,8,7,7,2,8,6,1,9,7,7,0,3,1,5,2,2,7,
     *7,6,6,4,2,1,5,8,0,2,0,9,2,6,2,0,8,0,0,9,5,8,4,8/
      DATA (KRAND(I),I=4561, 5016)
     */9,5,6,8,5,3,9,4,2,8,9,6,7,9,0,4,6,3,6,8,8,3,5,8,
     *0,6,5,8,5,1,9,5,2,5,9,8,2,8,8,6,3,3,8,2,4,6,7,0,
     *7,7,7,8,1,4,4,8,2,2,3,1,0,1,5,0,3,7,4,8,2,7,6,9,
     *3,3,2,0,3,2,4,1,8,5,4,7,6,6,1,1,8,1,6,4,2,3,1,2,
     *2,7,8,5,2,7,6,9,6,1,7,6,2,4,8,0,2,1,9,5,9,0,0,4,
     *4,8,2,2,8,2,8,0,8,0,6,8,5,7,2,2,2,5,6,8,3,7,6,0,
     *0,4,4,0,8,4,9,4,8,1,8,0,3,8,8,6,7,5,2,0,0,3,9,1,
     *0,2,4,3,5,7,9,5,6,5,3,0,0,9,0,1,0,0,9,6,6,4,2,7,
     *7,6,6,5,8,1,0,3,5,6,4,3,5,9,9,7,6,8,8,8,5,9,1,1,
     *8,9,2,1,9,7,6,7,6,0,7,0,0,4,9,5,2,5,2,1,4,0,8,8,
     *5,2,4,6,9,4,7,6,3,5,4,4,2,5,0,6,1,8,7,8,9,5,9,8,
     *2,1,7,6,9,8,7,7,9,3,5,3,2,9,9,9,0,5,2,3,0,9,2,1,
     *3,3,0,1,4,3,0,4,1,0,3,3,4,9,6,3,6,7,1,4,3,9,6,9,
     *3,3,2,1,8,2,9,6,2,8,8,1,9,9,8,9,5,9,3,3,3,3,7,4,
     *9,3,3,4,4,9,0,9,7,1,1,2,5,0,0,2,4,0,7,2,9,8,4,3,
     *3,2,3,7,9,8,3,2,7,8,1,9,0,0,7,7,6,3,7,0,6,2,5,9,
     *4,9,7,0,2,0,1,3,1,8,4,0,7,2,7,3,8,8,7,2,3,4,3,1,
     *4,4,0,1,4,1,9,5,0,8,3,5,9,8,4,5,3,7,3,8,0,2,8,1,
     *0,4,4,1,4,5,4,9,2,5,2,4,6,1,5,3,5,3,0,9,1,4,6,4/
      DATA (KRAND(I),I=5017, 5472)
     */8,6,5,0,1,5,0,5,0,2,0,7,3,6,2,4,6,6,5,3,2,4,9,4,
     *6,2,2,0,6,8,2,4,4,8,5,4,7,9,5,6,3,8,8,4,5,0,1,8,
     *3,7,2,6,4,6,9,4,6,0,9,0,6,8,4,8,9,9,0,0,2,1,1,2,
     *3,4,3,4,1,5,3,1,9,4,6,9,3,0,4,2,2,8,0,3,0,1,2,3,
     *6,5,4,8,9,6,1,6,2,8,2,7,1,1,9,8,3,0,9,1,4,9,5,7,
     *4,1,4,4,3,5,3,1,9,3,0,8,4,3,4,7,6,9,8,5,1,1,1,4,
     *0,3,1,2,3,6,1,7,2,8,1,2,3,1,7,2,2,6,6,6,9,9,7,3,
     *4,6,8,9,5,9,0,5,8,6,5,2,7,6,6,4,0,5,5,4,2,4,1,4,
     *6,9,2,2,8,0,7,0,7,8,6,0,0,6,0,4,9,5,8,2,0,0,8,2,
     *5,6,5,5,2,5,1,4,5,6,7,4,0,1,8,0,2,5,0,0,2,5,0,0,
     *1,4,1,8,6,1,0,3,3,8,8,0,2,9,5,6,5,2,2,4,1,5,2,2,
     *1,6,9,5,2,8,7,8,7,3,7,4,7,5,9,8,4,1,7,1,3,6,8,2,
     *9,6,1,7,4,2,6,9,1,6,6,3,8,4,2,7,6,5,8,7,2,5,5,2,
     *8,2,6,5,7,1,9,6,0,8,2,0,1,8,3,0,2,3,0,3,5,2,0,7,
     *7,2,1,3,1,0,3,0,4,8,0,0,8,3,0,0,2,6,0,3,9,6,5,6,
     *6,9,7,9,3,7,0,0,9,0,5,0,7,0,6,4,2,8,2,1,7,4,3,7,
     *5,9,0,2,0,0,4,6,8,7,9,4,2,2,6,1,1,9,0,6,7,2,7,9,
     *1,1,0,9,6,2,1,3,8,0,9,7,7,1,9,6,0,6,9,8,0,8,6,2,
     *0,3,6,6,3,0,3,2,4,9,6,6,9,0,8,9,7,1,9,6,3,6,8,1/
      DATA (KRAND(I),I=5473, 5928)
     */2,7,4,0,2,1,8,3,8,2,2,0,8,3,9,6,6,6,2,5,3,6,1,1,
     *2,9,8,2,5,4,6,8,8,7,2,5,6,4,5,5,8,7,2,9,4,9,7,8,
     *4,5,9,5,4,6,5,9,5,8,0,7,8,6,6,7,2,3,9,1,7,3,0,6,
     *3,8,0,1,5,2,0,1,4,5,5,8,3,0,1,2,6,1,1,3,0,9,9,5,
     *9,3,4,5,0,9,5,3,1,4,5,6,8,3,7,9,2,8,4,1,9,8,1,5,
     *0,7,8,6,1,0,7,2,7,9,5,5,2,6,9,9,8,1,5,7,5,0,0,8,
     *3,3,8,5,3,6,7,6,0,6,9,1,2,5,2,8,2,6,9,4,6,9,2,9,
     *8,9,3,1,8,6,1,4,3,5,8,5,3,1,4,3,4,9,8,0,3,3,2,0,
     *4,6,0,0,2,9,4,8,7,7,2,8,6,1,9,7,7,0,3,1,5,2,2,7,
     *7,6,6,4,2,1,5,8,0,2,0,9,2,6,2,0,8,0,0,9,5,8,4,8,
     *9,5,6,8,5,3,9,4,2,8,9,6,7,9,0,4,6,3,6,8,8,3,5,8,
     *0,6,5,8,5,1,9,5,2,5,9,8,2,8,8,6,3,3,8,2,4,6,7,0,
     *7,7,7,8,1,4,4,8,2,2,3,1,0,1,5,0,3,7,4,8,2,7,6,9,
     *3,3,2,0,3,2,4,1,8,5,4,7,6,6,1,1,8,1,6,4,2,3,1,2,
     *2,7,8,5,2,7,6,9,6,1,7,6,2,4,8,0,2,1,9,5,9,0,0,4,
     *4,8,2,2,8,2,8,0,8,0,6,8,5,7,2,2,2,5,6,8,3,7,6,0,
     *0,4,4,0,8,4,9,4,8,1,8,0,3,8,8,6,7,5,2,0,0,3,9,1,
     *0,2,4,3,5,7,9,5,6,5,3,0,0,9,0,1,0,0,9,6,6,4,2,7,
     *7,6,6,5,8,1,0,3,5,6,4,3,5,9,9,7,6,8,8,8,5,9,1,1/
      DATA (KRAND(I),I=5929, 6384)
     */8,9,2,1,9,7,6,7,6,0,7,0,0,4,9,5,2,5,2,1,4,0,8,8,
     *5,2,4,6,9,4,7,6,3,5,4,4,2,5,0,6,1,8,7,8,9,5,9,8,
     *2,1,7,6,9,8,7,7,9,3,5,3,2,9,9,9,0,5,2,3,0,9,2,1,
     *3,3,0,1,4,3,0,4,1,0,3,3,4,9,6,3,6,7,1,4,3,9,6,9,
     *3,3,2,1,8,2,9,6,2,8,8,1,9,9,8,9,5,9,3,3,3,3,7,4,
     *9,3,3,4,4,9,0,9,7,1,1,2,5,0,0,2,4,0,7,2,9,8,4,3,
     *3,2,3,7,9,8,3,2,7,8,1,9,0,0,7,7,6,3,7,0,6,2,5,9,
     *4,9,7,0,2,0,1,3,1,8,4,0,7,2,7,3,8,8,7,2,3,4,3,1,
     *4,4,0,1,4,1,9,5,0,8,3,5,9,8,4,5,3,7,3,8,0,2,8,1,
     *0,4,4,1,4,5,4,9,2,5,2,4,6,1,5,3,5,3,0,9,1,4,6,4,
     *8,6,5,0,1,5,0,5,0,2,0,7,3,6,2,4,6,6,5,3,2,4,9,4,
     *6,2,2,0,6,8,2,4,4,8,5,4,7,9,5,6,3,8,8,4,5,0,1,8,
     *3,7,2,6,4,6,9,4,6,0,9,0,6,8,4,8,9,9,0,0,2,1,1,2,
     *3,4,3,4,1,5,3,1,9,4,6,9,3,0,4,2,2,8,0,3,0,1,2,3,
     *6,5,4,8,9,6,1,6,2,8,2,7,1,1,9,8,3,0,9,1,4,9,5,7,
     *4,1,4,4,3,5,3,1,9,3,0,8,4,3,4,7,6,9,8,5,1,1,1,4,
     *0,3,1,2,3,6,1,7,2,8,1,2,3,1,7,2,2,6,6,6,9,9,7,3,
     *4,6,8,9,5,9,0,5,8,6,5,2,7,6,6,4,0,5,5,4,2,4,1,4,
     *6,9,2,2,8,0,7,0,7,8,6,0,0,6,0,4,9,5,8,2,0,0,8,2/
      DATA (KRAND(I),I=6385, 6840)
     */5,6,5,5,2,5,1,4,5,6,7,4,0,1,8,0,2,5,0,0,2,5,0,0,
     *1,4,1,8,6,1,0,3,3,8,8,0,2,9,5,6,5,2,2,4,1,5,2,2,
     *1,6,9,5,2,8,7,8,7,3,7,4,7,5,9,8,4,1,7,1,3,6,8,2,
     *9,6,1,7,4,2,6,9,1,6,6,3,8,4,2,7,6,5,8,7,2,5,5,2,
     *8,2,6,5,7,1,9,6,0,8,2,0,1,8,3,0,2,3,0,3,5,2,0,7,
     *7,2,1,3,1,0,3,0,4,8,0,0,8,3,0,0,2,6,0,3,9,6,5,6,
     *6,9,7,9,3,7,0,0,9,0,5,0,7,0,6,4,2,8,2,1,7,4,3,7,
     *5,9,0,2,0,0,4,6,8,7,9,4,2,2,6,1,1,9,0,6,7,2,7,9,
     *1,1,0,9,6,2,1,3,8,0,9,7,7,1,9,6,0,6,9,8,0,8,6,2,
     *0,3,6,6,3,0,3,2,4,9,6,6,9,0,8,9,7,1,9,6,3,6,8,1,
     *2,7,4,0,2,1,8,3,8,2,2,0,8,3,9,6,6,6,2,5,3,6,1,1,
     *2,9,8,2,5,4,6,8,8,7,2,5,6,4,5,5,8,7,2,9,4,9,7,8,
     *4,5,9,5,4,6,5,9,5,8,0,7,8,6,6,7,2,3,9,1,7,3,0,6,
     *3,8,0,1,5,2,0,1,4,5,5,8,3,0,1,2,6,1,1,3,0,9,9,5,
     *9,3,4,5,0,9,5,3,1,4,5,6,8,3,7,9,2,8,4,1,9,8,1,5,
     *0,7,8,6,1,0,7,2,7,9,5,5,2,6,9,9,8,1,5,7,5,0,0,8,
     *3,3,8,5,3,6,7,6,0,6,9,1,2,5,2,8,2,6,9,4,6,9,2,9,
     *8,9,3,1,8,6,1,4,3,5,8,5,3,1,4,3,4,9,8,0,3,3,2,0,
     *4,6,0,0,2,9,4,8,7,7,2,8,6,1,9,7,7,0,3,1,5,2,2,7/
      DATA (KRAND(I),I=6841, 7296)
     */7,6,6,4,2,1,5,8,0,2,0,9,2,6,2,0,8,0,0,9,5,8,4,8,
     *9,5,6,8,5,3,9,4,2,8,9,6,7,9,0,4,6,3,6,8,8,3,5,8,
     *0,6,5,8,5,1,9,5,2,5,9,8,2,8,8,6,3,3,8,2,4,6,7,0,
     *7,7,7,8,1,4,4,8,2,2,3,1,0,1,5,0,3,7,4,8,2,7,6,9,
     *3,3,2,0,3,2,4,1,8,5,4,7,6,6,1,1,8,1,6,4,2,3,1,2,
     *2,7,8,5,2,7,6,9,6,1,7,6,2,4,8,0,2,1,9,5,9,0,0,4,
     *4,8,2,2,8,2,8,0,8,0,6,8,5,7,2,2,2,5,6,8,3,7,6,0,
     *0,4,4,0,8,4,9,4,8,1,8,0,3,8,8,6,7,5,2,0,0,3,9,1,
     *0,2,4,3,5,7,9,5,6,5,3,0,0,9,0,1,0,0,9,6,6,4,2,7,
     *7,6,6,5,8,1,0,3,5,6,4,3,5,9,9,7,6,8,8,8,5,9,1,1,
     *8,9,2,1,9,7,6,7,6,0,7,0,0,4,9,5,2,5,2,1,4,0,8,8,
     *5,2,4,6,9,4,7,6,3,5,4,4,2,5,0,6,1,8,7,8,9,5,9,8,
     *2,1,7,6,9,8,7,7,9,3,5,3,2,9,9,9,0,5,2,3,0,9,2,1,
     *3,3,0,1,4,3,0,4,1,0,3,3,4,9,6,3,6,7,1,4,3,9,6,9,
     *3,3,2,1,8,2,9,6,2,8,8,1,9,9,8,9,5,9,3,3,3,3,7,4,
     *9,3,3,4,4,9,0,9,7,1,1,2,5,0,0,2,4,0,7,2,9,8,4,3,
     *3,2,3,7,9,8,3,2,7,8,1,9,0,0,7,7,6,3,7,0,6,2,5,9,
     *4,9,7,0,2,0,1,3,1,8,4,0,7,2,7,3,8,8,7,2,3,4,3,1,
     *4,4,0,1,4,1,9,5,0,8,3,5,9,8,4,5,3,7,3,8,0,2,8,1/
      DATA (KRAND(I),I=7297, 7752)
     */0,4,4,1,4,5,4,9,2,5,2,4,6,1,5,3,5,3,0,9,1,4,6,4,
     *8,6,5,0,1,5,0,5,0,2,0,7,3,6,2,4,6,6,5,3,2,4,9,4,
     *6,2,2,0,6,8,2,4,4,8,5,4,7,9,5,6,3,8,8,4,5,0,1,8,
     *3,7,2,6,4,6,9,4,6,0,9,0,6,8,4,8,9,9,0,0,2,1,1,2,
     *3,4,3,4,1,5,3,1,9,4,6,9,3,0,4,2,2,8,0,3,0,1,2,3,
     *6,5,4,8,9,6,1,6,2,8,2,7,1,1,9,8,3,0,9,1,4,9,5,7,
     *4,1,4,4,3,5,3,1,9,3,0,8,4,3,4,7,6,9,8,5,1,1,1,4,
     *0,3,1,2,3,6,1,7,2,8,1,2,3,1,7,2,2,6,6,6,9,9,7,3,
     *4,6,8,9,5,9,0,5,8,6,5,2,7,6,6,4,0,5,5,4,2,4,1,4,
     *6,9,2,2,8,0,7,0,7,8,6,0,0,6,0,4,9,5,8,2,0,0,8,2,
     *5,6,5,5,2,5,1,4,5,6,7,4,0,1,8,0,2,5,0,0,2,5,0,0,
     *1,4,1,8,6,1,0,3,3,8,8,0,2,9,5,6,5,2,2,4,1,5,2,2,
     *1,6,9,5,2,8,7,8,7,3,7,4,7,5,9,8,4,1,7,1,3,6,8,2,
     *9,6,1,7,4,2,6,9,1,6,6,3,8,4,2,7,6,5,8,7,2,5,5,2,
     *8,2,6,5,7,1,9,6,0,8,2,0,1,8,3,0,2,3,0,3,5,2,0,7,
     *7,2,1,3,1,0,3,0,4,8,0,0,8,3,0,0,2,6,0,3,9,6,5,6,
     *6,9,7,9,3,7,0,0,9,0,5,0,7,0,6,4,2,8,2,1,7,4,3,7,
     *5,9,0,2,0,0,4,6,8,7,9,4,2,2,6,1,1,9,0,6,7,2,7,9,
     *1,1,0,9,6,2,1,3,8,0,9,7,7,1,9,6,0,6,9,8,0,8,6,2/
      DATA (KRAND(I),I=7753, 8208)
     */0,3,6,6,3,0,3,2,4,9,6,6,9,0,8,9,7,1,9,6,3,6,8,1,
     *2,7,4,0,2,1,8,3,8,2,2,0,8,3,9,6,6,6,2,5,3,6,1,1,
     *2,9,8,2,5,4,6,8,8,7,2,5,6,4,5,5,8,7,2,9,4,9,7,8,
     *4,5,9,5,4,6,5,9,5,8,0,7,8,6,6,7,2,3,9,1,7,3,0,6,
     *3,8,0,1,5,2,0,1,4,5,5,8,3,0,1,2,6,1,1,3,0,9,9,5,
     *9,3,4,5,0,9,5,3,1,4,5,6,8,3,7,9,2,8,4,1,9,8,1,5,
     *0,7,8,6,1,0,7,2,7,9,5,5,2,6,9,9,8,1,5,7,5,0,0,8,
     *3,3,8,5,3,6,7,6,0,6,9,1,2,5,2,8,2,6,9,4,6,9,2,9,
     *8,9,3,1,8,6,1,4,3,5,8,5,3,1,4,3,4,9,8,0,3,3,2,0,
     *4,6,0,0,2,9,4,8,7,7,2,8,6,1,9,7,7,0,3,1,5,2,2,7,
     *7,6,6,4,2,1,5,8,0,2,0,9,2,6,2,0,8,0,0,9,5,8,4,8,
     *9,5,6,8,5,3,9,4,2,8,9,6,7,9,0,4,6,3,6,8,8,3,5,8,
     *0,6,5,8,5,1,9,5,2,5,9,8,2,8,8,6,3,3,8,2,4,6,7,0,
     *7,7,7,8,1,4,4,8,2,2,3,1,0,1,5,0,3,7,4,8,2,7,6,9,
     *3,3,2,0,3,2,4,1,8,5,4,7,6,6,1,1,8,1,6,4,2,3,1,2,
     *2,7,8,5,2,7,6,9,6,1,7,6,2,4,8,0,2,1,9,5,9,0,0,4,
     *4,8,2,2,8,2,8,0,8,0,6,8,5,7,2,2,2,5,6,8,3,7,6,0,
     *0,4,4,0,8,4,9,4,8,1,8,0,3,8,8,6,7,5,2,0,0,3,9,1,
     *0,2,4,3,5,7,9,5,6,5,3,0,0,9,0,1,0,0,9,6,6,4,2,7/
      DATA (KRAND(I),I=8209, 8664)
     */7,6,6,5,8,1,0,3,5,6,4,3,5,9,9,7,6,8,8,8,5,9,1,1,
     *8,9,2,1,9,7,6,7,6,0,7,0,0,4,9,5,2,5,2,1,4,0,8,8,
     *5,2,4,6,9,4,7,6,3,5,4,4,2,5,0,6,1,8,7,8,9,5,9,8,
     *2,1,7,6,9,8,7,7,9,3,5,3,2,9,9,9,0,5,2,3,0,9,2,1,
     *3,3,0,1,4,3,0,4,1,0,3,3,4,9,6,3,6,7,1,4,3,9,6,9,
     *3,3,2,1,8,2,9,6,2,8,8,1,9,9,8,9,5,9,3,3,3,3,7,4,
     *9,3,3,4,4,9,0,9,7,1,1,2,5,0,0,2,4,0,7,2,9,8,4,3,
     *3,2,3,7,9,8,3,2,7,8,1,9,0,0,7,7,6,3,7,0,6,2,5,9,
     *4,9,7,0,2,0,1,3,1,8,4,0,7,2,7,3,8,8,7,2,3,4,3,1,
     *4,4,0,1,4,1,9,5,0,8,3,5,9,8,4,5,3,7,3,8,0,2,8,1,
     *0,4,4,1,4,5,4,9,2,5,2,4,6,1,5,3,5,3,0,9,1,4,6,4,
     *8,6,5,0,1,5,0,5,0,2,0,7,3,6,2,4,6,6,5,3,2,4,9,4,
     *6,2,2,0,6,8,2,4,4,8,5,4,7,9,5,6,3,8,8,4,5,0,1,8,
     *3,7,2,6,4,6,9,4,6,0,9,0,6,8,4,8,9,9,0,0,2,1,1,2,
     *3,4,3,4,1,5,3,1,9,4,6,9,3,0,4,2,2,8,0,3,0,1,2,3,
     *6,5,4,8,9,6,1,6,2,8,2,7,1,1,9,8,3,0,9,1,4,9,5,7,
     *4,1,4,4,3,5,3,1,9,3,0,8,4,3,4,7,6,9,8,5,1,1,1,4,
     *0,3,1,2,3,6,1,7,2,8,1,2,3,1,7,2,2,6,6,6,9,9,7,3,
     *4,6,8,9,5,9,0,5,8,6,5,2,7,6,6,4,0,5,5,4,2,4,1,4/
      DATA (KRAND(I),I=8665, 8784)
     */6,9,2,2,8,0,7,0,7,8,6,0,0,6,0,4,9,5,8,2,0,0,8,2,
     *5,6,5,5,2,5,1,4,5,6,7,4,0,1,8,0,2,5,0,0,2,5,0,0,
     *1,4,1,8,6,1,0,3,3,8,8,0,2,9,5,6,5,2,2,4,1,5,2,2,
     *1,6,9,5,2,8,7,8,7,3,7,4,7,5,9,8,4,1,7,1,3,6,8,2,
     *9,6,1,7,4,2,6,9,1,6,6,3,8,4,2,7,6,5,8,7,2,5,5,2/

      END

C       Calculates either the average of the four nearest data points
C       as the missing value, or the average of the same hours from
C       the day before and the day after.  This version is for real inputs

      Subroutine Miss4Scaler(var,i,j,k,missval,ileap,ichange)

        REAL var(12,31,24)
        REAL missval
        REAL lvar,lvar2
        REAL subval(4)

        INTEGER dap(12)

        DATA dap /31,28,31,30,31,30,31,31,30,31,30,31/

        IF(ileap .EQ. 1) dap(2) = 29

        icalc = 0
        isub=0
        lvar = 0.
        lvar2 = 0.
        do 5 ir=1,12
         do 5 jr=1,dap(ir)
          do 5 kr=1,24
            IF(isub.eq.2) then
              subval(4) = var(ir,jr,kr)
              GOTO 10
            endif
            IF(isub.eq.1) then
              subval(3) = var(ir,jr,kr)
              isub=2
            endif
            IF(i.eq.ir .AND. j.EQ.jr .AND. k.eq.kr) then
              subval(1) = lvar2
              subval(2) = lvar
              isub=1
            endif
            lvar2 = lvar
            lvar = var(ir,jr,kr)
5	continue

10      do ir=1,4
          IF(subval(ir) .LT. 998) icalc=icalc+1
	end do

        IF(icalc .EQ. 4) then
          missval=(subval(1)+subval(2)+subval(3)+subval(4))/4.
          ichange = 1
          GOTO 50
        endif

C       Next try to substitute the average of day before and after

        isub=0
        lvar = 0.
        subval(1) = 0.
        subval(2) = 0.
        do 25 ir=1,12
         do 25 jr=1,dap(ir)
            IF(isub.eq.1) then
              subval(2) = var(ir,jr,k)
              isub=2
              GOTO 27
            endif
            IF(i.eq.ir .AND. j.EQ.jr) then
              subval(1) = lvar
              isub=1
            endif
            lvar = var(ir,jr,k)
25	continue

27      IF(subval(1).lt.998 .AND. subval(2) .LT.998) then
          missval = (subval(1)+subval(2))/2.
          ichange = 2
        else
          missval = 999
        endif

50      END Subroutine


C       Calculates either the average of the four nearest data points
C       as the missing value, or the average of the same hours from
C       the day before and the day after.  This version is for integer inputs

        Subroutine Miss4Scaler_Integer(var,i,j,k,imissval,ileap)

        integer var(12,31,24)
        integer imissval
        integer lvar,lvar2
        integer subval(4)
        INTEGER dap(12)

        REAL missval

        DATA dap /31,28,31,30,31,30,31,31,30,31,30,31/

        IF(ileap .EQ. 1) dap(2) = 29

        icalc = 0
        isub=0
        lvar = 0.
        lvar2 = 0.
        do 5 ir=1,12
         do 5 jr=1,dap(ir)
          do 5 kr=1,24
            IF(isub.eq.2) then
              subval(4) = var(ir,jr,kr)
              GOTO 10
            endif
            IF(isub.eq.1) then
              subval(3) = var(ir,jr,kr)
              isub=2
            endif
            IF(i.eq.ir .AND. j.EQ.jr .AND. k.eq.kr) then
              subval(1) = lvar2
              subval(2) = lvar
              isub=1
            endif
            lvar2 = lvar
            lvar = var(ir,jr,kr)
5	continue

10      do ir=1,4
          IF(subval(ir) .LT. 998) icalc=icalc+1
	end do


        IF(icalc .EQ. 4) then
          missval=(subval(1)+subval(2)+subval(3)+subval(4))/4.
          imissval = INT(missval)
          IF((missval-imissval) .GE. 0.5) imissval = imissval + 1
          ichange = 1
          GOTO 50
        endif

C       Next try to substitute the average of day before and after

        isub=0
        lvar = 0.
        subval(1) = 0.
        subval(2) = 0.
        do 25 ir=1,12
         do 25 jr=1,dap(ir)
            IF(isub.eq.1) then
              subval(2) = var(ir,jr,k)
              isub=2
              GOTO 27
            endif
            IF(i.eq.ir .AND. j.EQ.jr) then
              subval(1) = lvar
              isub=1
            endif
            lvar = var(ir,jr,k)
25	continue

27      IF(subval(1).lt.998 .AND. subval(2) .LT.998) then
          missval = (subval(1)+subval(2))/2.
          imissval = INT(missval)
          IF((missval-imissval) .GE. 0.5) imissval = imissval + 1
          ichange = 2
        else
          imissval = 999
        endif

50      END Subroutine

C       Calculates either the average of the four nearest data points
C       as the missing value, or the average of the same hours from
C       the day before and the day after.  This version is for vectors.

        Subroutine Miss4Vector(var,i,j,k,missval,ileap,ichange)

        integer var(12,31,24)
        integer missval
        integer lvar,lvar2
        integer subval(4)

        REAL ve,vn,ArcTanVeVn,FLOW

        INTEGER dap(12)

        DATA dap /31,28,31,30,31,30,31,31,30,31,30,31/

        IF(ileap .EQ. 1) dap(2) = 29
        ichange = 0

        ve = 0.
        vn = 0.
        isub=0
        lvar = 0.
        lvar2 = 0.
        do 5 ir=1,12
         do 5 jr=1,dap(ir)
          do 5 kr=1,24

            IF(isub.eq.2) then
              IF(var(ir,jr,kr) .GT. 998 .or. var(ir,jr,kr) .eq. 0)
     >          goto 20
              ve = ve + sin(float(var(ir,jr,kr))*3.1416/180.)
              vn = vn + cos(float(var(ir,jr,kr))*3.1416/180.)
              IF(i .EQ. 10 .AND. j .EQ. 30) PRINT *,var(ir,jr,kr)
              GOTO 10
            endif
            IF(isub.eq.1) then
             IF(var(ir,jr,kr) .GT. 998 .or. var(ir,jr,kr) .eq. 0)
     >          goto 20
              ve = ve + sin(float(var(ir,jr,kr))*3.1416/180.)
              vn = vn + cos(float(var(ir,jr,kr))*3.1416/180.)
              IF(i .EQ. 10 .AND. j .EQ. 30) PRINT *,var(ir,jr,kr)
              isub=2
            endif
            IF(i.eq.ir .AND. j.EQ.jr .AND. k.eq.kr) then
              IF(lvar .GT. 998 .or. lvar .eq. 0) goto 20
              ve = ve + sin(float(lvar)*3.1416/180.)
              vn = vn + cos(float(lvar)*3.1416/180.)
              IF(lvar2 .GT. 998 .or. lvar .eq. 0) goto 20
              ve = ve + sin(float(lvar2)*3.1416/180.)
              vn = vn + cos(float(lvar2)*3.1416/180.)
              isub=1
              IF(i .EQ. 10 .AND. j .EQ. 30) PRINT *,lvar,lvar2
            endif
            lvar2 = lvar
            lvar = var(ir,jr,kr)
5	continue

10      ve = -(1./4.)*ve
        vn = -(1./4.)*vn

        if(vn .ne. 0.) then
          ArcTanVeVn = ATAN2(ve,vn)*180./3.1416
        else
          ArcTanVeVn = 0.
          PRINT *, 'ArcTanVeVn = 0'
        endif
        if(ArcTanVeVn .lt. 180.) then
          FLOW = 180
        else
          FLOW = -180
        endif
          
        missval = ArcTanVeVn + FLOW
        ichange = 1
        GOTO 50

C
C       Try substituting average from day before and after
C

20      isub = 0

        ve = 0.
        vn = 0.
        lvar = 0
        do 30 ir=1,12
         do 30 jr=1,dap(ir)

            IF(isub.eq.1) then
              IF(var(ir,jr,k) .GT. 998 .or. var(ir,jr,k) .eq. 0)
     >          goto 40
              ve = ve + sin(float(var(ir,jr,k))*3.1416/180.)
              vn = vn + cos(float(var(ir,jr,k))*3.1416/180.)

              subval(2) = var(ir,jr,k)
              GOTO 35
            endif
            IF(i .eq.ir .AND. j.EQ.jr) then

              IF(lvar .GT. 998 .or. lvar .eq. 0) goto 40
              ve = ve + sin(float(lvar)*3.1416/180.)
              vn = vn + cos(float(lvar)*3.1416/180.)
              isub=1
              subval(1) = lvar
            endif
            lvar = var(ir,jr,k)
30	continue

35      ve = -(1./2.)*ve
        vn = -(1./2.)*vn

        if(vn .ne. 0.) then
          ArcTanVeVn = ATAN2(ve,vn)*180./3.1416
        else
          ArcTanVeVn = 0.
          PRINT *, 'ArcTanVeVn = 0'
        endif
        if(ArcTanVeVn .lt. 180.) then
          FLOW = 180
        else
          FLOW = -180
        endif
          
        missval = ArcTanVeVn + FLOW

        ichange = 2
        GOTO 50


40      missval = 999


50      END Subroutine


