C     Last change:  RR   23 Jun 2004    3:22 pm
        PROGRAM FAWNMET

        CHARACTER*5 change_code(2)

        INTEGER KST,LST
        INTEGER lyr,lday,lmon
        INTEGER dap(12)
        INTEGER julmon(365),julday(365)
        INTEGER julmon_leap(366),julday_leap(366)

        REAL solarad,temp6,temp30,ws,wd,lwd
        REAL vector
        REAL wd_arr(12,31,24),ws_arr(12,31,24)
        real temp30_arr(12,31,24),temp6_arr(12,31,24)
        real solarad_arr(12,31,24)
        REAL missval

        DATA dap /31,28,31,30,31,30,31,31,30,31,30,31/

C       codes for missing data replacement.  HOUR is code for using the average of nearest
C       4 hours, and DAY is the code for using average of same hour from day before and after.
C       These codes appear in Bakersfield_subs.out file

        change_code(1) = 'HOUR '
        change_code(2) = 'DAY  '


C       initialize variables


        do 5 i=1,12
         do 5 j=1,31
          do 5 k=1,24
          wd_arr(i,j,k) = -9
          ws_arr(i,j,k) = -9.
          temp30_arr(i,j,k) = -9.
          temp6_arr(i,j,k) = -9.
          solarad_arr(i,j,k) = -9.
5       continue

        iws_comp = 0
        isolar_comp = 0
        itemp_comp = 0
        iwd_comp = 0

c       define julian days for processing

        ijul = 0
        do 10 i=1,12
         do 10 j=1,dap(i)
           ijul = ijul + 1
           julmon(ijul) = i
           julday(ijul) = j
10       continue

        dap(2) = 29
        ijul = 0
        do 11 i=1,12
         do 11 j=1,dap(i)
           ijul = ijul + 1
           julmon_leap(ijul) = i
           julday_leap(ijul) = j
11      continue


        lwd = 0
        lyr = 0
        lmon = 0
        lday = 0
        imiss = 0
        KST = -9

        OPEN(1,FILE='c:\arvesta\fawn-final\bradenton.csv',STATUS='old')
        READ(1,*)                       ! read header
        OPEN(2,FILE='c:\arvesta\fawn-final\brad.met')
        OPEN(9,FILE='c:\arvesta\fawn-final\subs.out')


        do 60 j=1,100000

          READ(1,*,IOSTAT=ios,ERR=59) iyr,imon,iday,ihr,temp6,temp30,
     >      solarad,ws,wd

            IF(j.eq.1) GOTO 60          ! don't need the first hour

C           adjust hours to conform to ISC format - hour 0 should be hour 24 of day before

            IF(iyr .EQ. 2000) then
              ileap = 1
            else
              ileap = 0
            endif
            IF(ihr .EQ. 0) then
              CALL GetJul(ijul,imon,iday,ileap)
              IF(imon .EQ. 1 .AND. iday .EQ. 1) then
                imon = 12
                iday = 31
                iyr = lyr
                IF(iyr .EQ. 2000) then
                  ileap = 1
                else
                  ileap = 0
                endif
              ELSEIF(ileap .EQ. 0) then
                imon = julmon(ijul-1)
                iday = julday(ijul-1)
              else
                imon = julmon_leap(ijul-1)
                iday = julday_leap(ijul-1)
              endif
              ihr = 24
            endif

C	    do some data checking - eliminate some anomolous values

            IF(solarad .GT. 1500. .OR. solarad .LT. 0.) then
c             PRINT *, ' Solar rad check:',iyr,imon,iday,ihr,solarad
              solarad = -9.
            endif
            IF(ws .LT. 0 .OR. ws .GT. 100.) then
c              PRINT *, ' Wind speed check:',iyr,imon,iday,ihr,ws
              ws = -9.
            endif
            IF(wd .EQ. 0 .OR. wd .GT. 360.) then
c             PRINT *, ' Wind direction check:',iyr,imon,iday,ihr,wd,ws
              wd = -9.
            endif

            IF(ws .gt. -8.) ws = ws*0.278       ! convert from km/hr to m/sec


C           if a full year has been read then process the data and calculate stability classes
C           and print out the results


59      IF(ios .LT. 0) iyr = iyr + 1         ! allow last hour to be processed

        IF(j .GT. 2 .AND. iyr .NE. lyr) then

          IF(lyr .EQ. 2000) then                ! leap year
            dap(2) = 29
            ileap = 1
          else
            dap(2) = 28
            ileap = 0
          endif

C         replace missing values

          do 150 ir=1,12
           do 150 jr=1,dap(ir)
            do 150 kr=1,24

            IF(ws_arr(ir,jr,kr) .LT. -8.) then
              iws_comp = iws_comp + 1
              CALL Miss4Scaler(ws_arr,ir,jr,kr,missval,ileap,ichange)
              IF(missval .LT. 999) then
                ws_arr(ir,jr,kr) = missval
                WRITE(9,41) lyr,ir,jr,kr,missval,change_code(ichange)
41              FORMAT(' WS        replaced at ',i4,1x,3(1x,i2),
     >            1x,f7.2,1x,a5)
              endif
            endif

            IF(solarad_arr(ir,jr,kr) .LT. -8.) then
              isolar_comp = isolar_comp + 1
              CALL Miss4Scaler(solarad_arr,ir,jr,kr,missval,ileap,
     >          ichange)
              IF(missval .LT. 999) then
                solarad_arr(ir,jr,kr) = missval
                WRITE(9,42) lyr,ir,jr,kr,missval,change_code(ichange)
42              FORMAT(' Solar Rad replaced at ',i4,1x,3(1x,i2),
     >            1x,f7.2,1x,a5)
              endif
            endif

            IF(temp30_arr(ir,jr,kr) .LT. -8.) then
              CALL Miss4Scaler(temp30_arr,ir,jr,kr,missval,ileap,
     >          ichange)
              IF(missval .LT. 999) then
                temp30_arr(ir,jr,kr) = missval
                WRITE(9,43) lyr,ir,jr,kr,missval,change_code(ichange)
43              FORMAT(' Temp30    replaced at ',i4,1x,3(1x,i2),
     >            1x,f7.2,1x,a5)
              endif
            endif

            IF(temp6_arr(ir,jr,kr) .LT. -8.) then
              itemp_comp = itemp_comp + 1
              CALL Miss4Scaler(temp6_arr,ir,jr,kr,missval,ileap,
     >          ichange)
              IF(missval .LT. 999) then
                temp6_arr(ir,jr,kr) = missval
                WRITE(9,44) lyr,ir,jr,kr,missval,change_code(ichange)
44              FORMAT(' Temp6     replaced at ',i4,1x,3(1x,i2),
     >            1x,f7.2,1x,a5)
              endif
            endif

            IF(wd_arr(ir,jr,kr) .LT. -8.) then
              iwd_comp = iwd_comp + 1
              CALL Miss4Vector(wd_arr,ir,jr,kr,missval,ileap,
     >          ichange)
              IF(missval .LT. 999) then
                wd_arr(ir,jr,kr) = missval
                WRITE(9,45) lyr,ir,jr,kr,missval,change_code(ichange)
45              FORMAT(' Wd        replaced at ',i4,1x,3(1x,i2),
     >            1x,f7.2,1x,a5)
              endif
            endif

150       continue


C         Process the data

          do 200 ir=1,12
           do 200 jr=1,dap(ir)
            do 200 kr=1,24

            IF(solarad_arr(ir,jr,kr) .LT. -8.) then
              PRINT *, ' Missing Solar Radiation: ',lyr,ir,jr,kr
            endif
            IF(ws_arr(ir,jr,kr) .LT. -8.) then
              PRINT *, ' Missing wind speed: ',lyr,ir,jr,kr
            endif
            IF(wd_arr(ir,jr,kr) .LT. -8.) then
              PRINT *, ' Missing wind direction: ',lyr,ir,jr,kr
            endif

C           calculate the stability classes

            IF(solarad_arr(ir,jr,kr) .GE. 925.) then
              IF(ws_arr(ir,jr,kr) .LT. 2) then
                KST = 1
              ELSEIF(ws_arr(ir,jr,kr) .GE. 2 .AND.
     >          ws_arr(ir,jr,kr) .LT. 3) then
                  KST = 1
              ELSEIF(ws_arr(ir,jr,kr) .GE. 3 .AND.
     >          ws_arr(ir,jr,kr) .LT. 5) then
                  KST = 2
              ELSEIF(ws_arr(ir,jr,kr) .GE. 5 .AND.
     >          ws_arr(ir,jr,kr) .LT. 6) then
                  KST = 3
              ELSEIF(ws_arr(ir,jr,kr) .GE. 6) then
                KST = 3
              else
                PRINT *, 'Invalid ws :',iyr,imon,iday,ws_arr(ir,jr,kr)
              endif
            ELSEIF(solarad_arr(ir,jr,kr) .LT. 925. .AND.
     >          solarad_arr(ir,jr,kr) .GE. 675.) then
              IF(ws_arr(ir,jr,kr) .LT. 2) then
                KST = 1
              ELSEIF(ws_arr(ir,jr,kr) .GE. 2 .AND.
     >          ws_arr(ir,jr,kr) .LT. 3) then
                  KST = 2
              ELSEIF(ws_arr(ir,jr,kr) .GE. 3 .AND.
     >          ws_arr(ir,jr,kr) .LT. 5) then
                  KST = 2
              ELSEIF(ws_arr(ir,jr,kr) .GE. 5 .AND.
     >          ws_arr(ir,jr,kr) .LT. 6) then
                  KST = 3
              ELSEIF(ws_arr(ir,jr,kr) .GE. 6) then
                KST = 4
              else
                PRINT *, 'Invalid ws :',iyr,imon,iday,ws_arr(ir,jr,kr)
              endif
            ELSEIF(solarad_arr(ir,jr,kr) .GE. 175. .AND.
     >          solarad_arr(ir,jr,kr) .LT. 675.) then
              IF(ws_arr(ir,jr,kr) .LT. 2) then
                KST = 2
              ELSEIF(ws_arr(ir,jr,kr) .GE. 2 .AND.
     >          ws_arr(ir,jr,kr) .LT. 3) then
                  KST = 3
              ELSEIF(ws_arr(ir,jr,kr) .GE. 3 .AND.
     >          ws_arr(ir,jr,kr) .LT. 5) then
                  KST = 3
              ELSEIF(ws_arr(ir,jr,kr) .GE. 5 .AND.
     >          ws_arr(ir,jr,kr) .LT. 6) then
                  KST = 4
              ELSEIF(ws_arr(ir,jr,kr) .GE. 6) then
                KST = 4
              else
                PRINT *, 'Invalid ws :',iyr,imon,iday,ws_arr(ir,jr,kr)
              endif
            ELSEIF(solarad_arr(ir,jr,kr) .GE. 1. .AND.
     >          solarad_arr(ir,jr,kr) .LE. 175.) then
              IF(ws_arr(ir,jr,kr) .LT. 2) then
                KST = 4
              ELSEIF(ws_arr(ir,jr,kr) .GE. 2 .AND.
     >          ws_arr(ir,jr,kr) .LT. 3) then
                  KST = 4
              ELSEIF(ws_arr(ir,jr,kr) .GE. 3 .AND.
     >          ws_arr(ir,jr,kr) .LT. 5) then
                  KST = 4
              ELSEIF(ws_arr(ir,jr,kr) .GE. 5 .AND.
     >          ws_arr(ir,jr,kr) .LT. 6) then
                  KST = 4
              ELSEIF(ws_arr(ir,jr,kr) .GE. 6) then
                KST = 4
              else
                PRINT *, 'Invalid ws :',iyr,imon,iday,ws_arr(ir,jr,kr)
              endif
            ELSEIF(solarad_arr(ir,jr,kr) .GE. 0 .AND.
     >          solarad_arr(ir,jr,kr) .LT. 1.) then   ! nighttime
              tempdiff = (temp30_arr(ir,jr,kr)-temp6_arr(ir,jr,kr))
              IF(tempdiff .LT. 0.) then
                IF(ws_arr(ir,jr,kr) .LT. 2.) then
                  KST = 5
                ELSEIF(ws_arr(ir,jr,kr) .GE. 2 .AND.
     >            ws_arr(ir,jr,kr) .LT. 2.5) then
                    KST = 4
                else
                  KST = 4
                endif
              else
                IF(ws_arr(ir,jr,kr) .LT. 2.) then
                  KST = 6
                ELSEIF(ws_arr(ir,jr,kr) .GE. 2 .AND.
     >            ws_arr(ir,jr,kr) .LT. 2.5) then
                    KST = 5
                else
                  KST = 4
                endif
              endif
            else
              PRINT *, 'Invalid solar radiation: ',ir,jr,kr,
     >          solarad_arr(ir,jr,kr)
            endif

C           make sure the stability does not advance by more than one class; if reading a day
C           following a missing day then don't enforce for first hour

            IF(ir.eq. 1.and.jr.eq.1.and.kr.eq.1) LST=KST
            IF ((KST-LST).GT.1) KST=LST+1
            IF ((LST-KST).GT.1) KST=LST-1
            LST=KST

C           implement calms processing

            IF(ws_arr(ir,jr,kr) .LT. 1.0) then
              ws_arr(ir,jr,kr) = 0.0
              wd_arr(ir,jr,kr) = lwd
            endif
            lwd = wd_arr(ir,jr,kr)

C           convert wind direction to a vector

            IF(wd_arr(ir,jr,kr).GT.180.0) THEN
              vector=wd_arr(ir,jr,kr)-180.0
            ELSE
              vector=wd_arr(ir,jr,kr)+180.0
            ENDIF

C           print results

            imiss = 0
            IF(wd_arr(ir,jr,kr) .LT. -8.) imiss = 1
            IF(ws_arr(ir,jr,kr) .LT. -8.) imiss = 2
            IF(temp30_arr(ir,jr,kr) .LT. -8) temp30_arr(ir,jr,kr) = 25.
            IF(KST .LT. -8) imiss = 1
                         
            IF(imiss .EQ. 0) then
              IF(lyr .EQ. 1999) then
                iyr_tmp = 99
              else
                iyr_tmp = lyr - 2000
              endif

              temp_tmp = temp30_arr(ir,jr,kr) + 273.

              WRITE(2,901) iyr_tmp,ir,jr,kr,vector,
     >           ws_arr(ir,jr,kr),temp_tmp,KST
901           FORMAT(4(i2.2),f9.4,f9.4,f6.1,i2,'  300.0','  300.0')

            else
              PRINT *, ' Missing data for :',iyr_tmp,ir,jr,kr
            endif

200       continue

C         reinitialize annual arrays

          do 205 ir=1,12
           do 205 jr=1,31
            do 205 kr=1,24
              wd_arr(ir,jr,kr) = -9
              ws_arr(ir,jr,kr) = -9.
              temp30_arr(ir,jr,kr) = -9.
              temp6_arr(ir,jr,kr) = -9.
              solarad_arr(ir,jr,kr) = -9.
205       continue


        endif

C       store data into arrays for processing

        ws_arr(imon,iday,ihr) = ws
        wd_arr(imon,iday,ihr) = wd
        solarad_arr(imon,iday,ihr) = solarad
        temp30_arr(imon,iday,ihr) = temp30
        temp6_arr(imon,iday,ihr) = temp6


        lyr = iyr
        lmon = imon
        lday = iday


        IF(ios .LT. 0) GOTO 99           ! if last hour is processed, jump out of loop


60      continue

99      CLOSE(1)
        CLOSE(2)
        CLOSE(9)

C       print out data completeness statistics

        PRINT *, ' Wind speed missing hours ',iws_comp
        PRINT *, ' Solar radiation missing hours: ',isolar_comp
        PRINT *, ' Temperature missing hours: ',itemp_comp
        PRINT *, ' Wind direction missing hours: ',iwd_comp


        END PROGRAM


C       Calculates either the average of the four nearest data points
C       as the missing value, or the average of the same hours from
C       the day before and the day after.  This version is for real inputs

      Subroutine Miss4Scaler(var,i,j,k,missval,ileap,ichange)

        REAL var(12,31,24)
        REAL missval
        REAL lvar,lvar2
        REAL subval(4)

        INTEGER dap(12)

        DATA dap /31,28,31,30,31,30,31,31,30,31,30,31/

        IF(ileap .EQ. 1) then
          dap(2) = 29
        else
          dap(2) = 28
        endif

        icalc = 0
        isub=0
        lvar = 0.
        lvar2 = 0.
        do 5 ir=1,12
         do 5 jr=1,dap(ir)
          do 5 kr=1,24
            IF(isub.eq.2) then
              subval(4) = var(ir,jr,kr)
              GOTO 10
            endif
            IF(isub.eq.1) then
              subval(3) = var(ir,jr,kr)
              isub=2
            endif
            IF(i.eq.ir .AND. j.EQ.jr .AND. k.eq.kr) then
              subval(1) = lvar2
              subval(2) = lvar
              isub=1
            endif
            lvar2 = lvar
            lvar = var(ir,jr,kr)
5	continue

10      do ir=1,4
          IF(subval(ir) .gt. -8) icalc=icalc+1
	end do

        IF(icalc .EQ. 4) then
          missval=(subval(1)+subval(2)+subval(3)+subval(4))/4.
          ichange = 1
          GOTO 50
        endif

C       Next try to substitute the average of day before and after

        isub=0
        lvar = 0.
        subval(1) = 0.
        subval(2) = 0.
        do 25 ir=1,12
         do 25 jr=1,dap(ir)
            IF(isub.eq.1) then
              subval(2) = var(ir,jr,k)
              isub=2
              GOTO 27
            endif
            IF(i.eq.ir .AND. j.EQ.jr) then
              subval(1) = lvar
              isub=1
            endif
            lvar = var(ir,jr,k)
25	continue


27      IF(subval(1).GT.-8. .AND. subval(2).GT.-8) then
          missval = (subval(1)+subval(2))/2.
          ichange = 2
        else
          missval = 999
        endif

50      END Subroutine

C       Calculates either the average of the four nearest data points
C       as the missing value, or the average of the same hours from
C       the day before and the day after.  This version is for vectors.

        Subroutine Miss4Vector(var,i,j,k,missval,ileap,ichange)

        real var(12,31,24)
        real missval
        real lvar,lvar2
        real subval(4)

        REAL ve,vn,ArcTanVeVn,FLOW

        INTEGER dap(12)

        DATA dap /31,28,31,30,31,30,31,31,30,31,30,31/

        IF(ileap .EQ. 1) then
          dap(2) = 29
        else
          dap(2) = 28
        endif

        ichange = 0

        ve = 0.
        vn = 0.
        isub=0
        lvar = 0.
        lvar2 = 0.
        do 5 ir=1,12
         do 5 jr=1,dap(ir)
          do 5 kr=1,24

            IF(isub.eq.2) then
              IF(var(ir,jr,kr) .lt. -8. .or. var(ir,jr,kr) .eq. 0)
     >          goto 20
              ve = ve + sin(var(ir,jr,kr)*3.1416/180.)
              vn = vn + cos(var(ir,jr,kr)*3.1416/180.)
              GOTO 10
            endif
            IF(isub.eq.1) then
             IF(var(ir,jr,kr) .lt. -8. .or. var(ir,jr,kr) .eq. 0)
     >          goto 20
              ve = ve + sin(var(ir,jr,kr)*3.1416/180.)
              vn = vn + cos(var(ir,jr,kr)*3.1416/180.)
              isub=2
            endif
            IF(i.eq.ir .AND. j.EQ.jr .AND. k.eq.kr) then
              IF(lvar .LT. -8. .or. lvar .eq. 0) goto 20
              ve = ve + sin(lvar*3.1416/180.)
              vn = vn + cos(lvar*3.1416/180.)
              IF(lvar2 .LT. -8. .or. lvar .eq. 0) goto 20
              ve = ve + sin(lvar2*3.1416/180.)
              vn = vn + cos(lvar2*3.1416/180.)
              isub=1
            endif
            lvar2 = lvar
            lvar = var(ir,jr,kr)
5	continue

10      ve = -(1./4.)*ve
        vn = -(1./4.)*vn

        if(vn .ne. 0.) then
          ArcTanVeVn = ATAN2(ve,vn)*180./3.1416
        else
          ArcTanVeVn = 0.
          PRINT *, 'ArcTanVeVn = 0'
        endif
        if(ArcTanVeVn .lt. 180.) then
          FLOW = 180
        else
          FLOW = -180
        endif
          
        missval = ArcTanVeVn + FLOW
        ichange = 1
        GOTO 50

C
C       Try substituting average from day before and after
C

20      isub = 0

        IF(i.eq.2.and.j.eq.1.and.k.eq.7) then
          PRINT *, i,j,k
        endif

        ve = 0.
        vn = 0.
        lvar = 0
        do 30 ir=1,12
         do 30 jr=1,dap(ir)

            IF(isub.eq.1) then
              IF(var(ir,jr,k) .LT. -8 .or. var(ir,jr,k) .eq. 0)
     >          goto 40
              ve = ve + sin(var(ir,jr,k)*3.1416/180.)
              vn = vn + cos(var(ir,jr,k)*3.1416/180.)

              subval(2) = var(ir,jr,k)
              GOTO 35
            endif
            IF(i .eq.ir .AND. j.EQ.jr) then

              IF(lvar .LT. -8 .or. lvar .eq. 0) goto 40
              ve = ve + sin(lvar*3.1416/180.)
              vn = vn + cos(lvar*3.1416/180.)
              isub=1
              subval(1) = lvar
            endif
            lvar = var(ir,jr,k)
30	continue

35      ve = -(1./2.)*ve
        vn = -(1./2.)*vn

        if(vn .ne. 0.) then
          ArcTanVeVn = ATAN2(ve,vn)*180./3.1416
        else
          ArcTanVeVn = 0.
          PRINT *, 'ArcTanVeVn = 0'
        endif
        if(ArcTanVeVn .lt. 180.) then
          FLOW = 180
        else
          FLOW = -180
        endif
          
        missval = ArcTanVeVn + FLOW

        ichange = 2
        GOTO 50


40      missval = 999


50      END Subroutine


        SUBROUTINE GetJul(ijul,imon,iday,ileap)

        INTEGER dap(12)

        DATA dap /31,28,31,30,31,30,31,31,30,31,30,31/

        IF(ileap .EQ. 1) then
          dap(2) = 29
        else
          dap(2) = 28
        endif

        kjul = 0
        do 100 i=1,12
         do 100 j=1,dap(i)
           kjul = kjul + 1
           IF(imon .EQ. i .AND. iday .EQ. j) then
             ijul = kjul
             GOTO 101
           endif
100     continue

101     END SUBROUTINE
